-------------------------------------------------------------------------------
--
--  Title      : 블링크의 전투 메세지 v2.1.0
--  Version    : 2.1.0
--  Author     : Blink
--  Date       : 2005/??/??
--  LastUpdate : 2007/02/15
--
-------------------------------------------------------------------------------

local debug = false;

-- 버전
BCF_VERSION = "v2.1.0";
BCF_VERSION_N = 2.10;

-- 기본 옵션 설정값
BlinkCombatFeed_Default = {
	VERSION = BCF_VERSION_N,
	ENABLE = 1,
	FONTSIZE = 20,
	USECUSTOMEVENT = 1,
	SHOWCOMBO = 1,
	SHOWINOUTCOMBAT = 1,
	DIRECTION = 1,
	HIDEMSG = 0,
	SHOWSPELLSCHOOL = 1,
	SHOWSPELLNAME = 1,
	SHOWHEAL = 1,
	SHOWOVERHEAL = 1,
	SHOWDAMAGE = 1,
--		SHOWDAMAGEPHYSICAL = 1,
--		SHOWDAMAGESPELL = 1,
	SHOWDEFENSE = 1,
		SHOWMISS = 1,
		SHOWRESIST = 1,
		SHOWDODGE = 1,
		SHOWPARRY = 1,
		SHOWBLOCK = 1,
		SHOWEVADE = 1,
		SHOWIMMUNE = 1,
		SHOWDEFLECT = 1,
		SHOWABSORB = 1,
		SHOWREFLECT = 1,
	SHOWLOWHEALTH = 1,
	LOWHEALTHVALUE = 0.4,
	SHOWLOWMANA = 1,
	LOWMANAVALUE = 0.4,
	SHOWGAINPOWER = 1,
	SHOWDOUBLEHIT = 1,
	SHOWHONOR = 1,
	SHOWREPUTATIONUP = 1,
	SHOWREPUTATIONDOWN = 1,
	SHOWAUTOREPUTATION = 1,
	SHOWSPELLACTIVE = 1,
	SHOWHITMISS = 1,
	SHOWTYPECOLOR = 1,
	-- 추가 설정
	SHOWCRITHIT = 0,
	SHOWNORMALHIT = 0,
	SHOWPETHIT = 0,
	SHOWBUFFING = 1,
	SHOWDEBUFFING = 1
};

BlinkCombatFeed_Color_Default = {
	INOUTCOMBAT = { r=0.8, g=0.8, b=0.8 },
	COMBO = { r=0.8, g=0.8, b=0.125 },
	SPELLDAMAGE = { r=0.5, g=0.0, b=0.0 },
	NORMALDAMAGE = { r=1.0, g=0.2, b=0.2 },
	INTERRUPT = { r=0.0, g=0.42, b=1.0 },
	MISS = { r=0.0, g=0.42, b=1.0 },
	DODGE = { r=0.0, g=0.42, b=1.0 },
	RESIST = { r=0.0, g=0.42, b=1.0 },
	PARRY = { r=0.0, g=0.42, b=1.0 },
	BLOCK = { r=0.0, g=0.42, b=1.0 },
	EVADE = { r=0.0, g=0.42, b=1.0 },
	IMMUNE = { r=0.0, g=0.42, b=1.0 },
	DEFLECT = { r=0.0, g=0.42, b=1.0 },
	ABSORB = { r=0.0, g=0.42, b=1.0 },
	REFLECT = { r=0.0, g=0.42, b=1.0 },
	HEAL = { r=0.0, g=1.0, b=0.0 },
	ENERGIZE = { r=0.41, g=0.8, b=0.94 },
	GAINPOWER = { r=1.0, g=0.6, b=0.2 },
	GAINHONOR = { r=0.6, g=0.6, b=0.13 },
	GAINREPUT = { r=0.1, g=0.45, b=0.43 },
	LOSTREPUT = { r=0.58, g=0.32, b=0.18 },
	LOWHEALTH = { r=0.75, g=0.25, b=0.25 },
	LOWMANA = { r=0.25, g=0.25, b=0.75 },
	SPELLACTIVE = { r=1.0, g=0.8, b=0.8 },
	DOUBLEHIT = {r=1.0,g=0.2,b=0.2},
	-- 속성 데미지 색상
	Holy = {r=1, g=1, b=0.627},
	Fire = {r=1, g=0.5, b=0.5},
	Nature = {r=0.5, g=1, b=0.5},
	Frost = {r=0.5, g=0.5, b=1},
	Shadow = {r=0.628, g=0, b=0.628},
	Arcane = {r=1, g=0.725, b=1},
	-- 파워회복 색상
	GAINRAGE = {r=1.0, g=0, b=0},
	GAINENERGY = { r=1, g=1, b=0 },
	GAINMANA = {r=0.32,g=0.5,b=1},
	-- 추가 색상
	ENEMYSPELLDAMAGE = {r=0.8,g=0.8,b=0.1},
	ENEMYNORMALDAMAGE = {r=1.0,g=1.0,b=1.0},
	ENEMYPERIODICDAMAGE = {r=0.8,g=0.8,b=0.1},
	GAINAURAFUL = { r=0.7, g=0.7, b=0.0 },
	LOSTAURAFUL = { r=0.58, g=0.32, b=0.18 },
	ENEMYPETNORMALDAMAGE = { r=1, g=0.48, b=0 },
	ENEMYPETSPELLDAMAGE = { r=1, g=0.48, b=0 }, 
};

-- 패널 갯수
BCF_MAX_PANEL = 20;

-- 패널의 움직이는 범위
BCF_MOVING_RANGE = 160;

-- 패널좌우 흔들림거리
BCF_PANEL_STAGGER_RANGE = 40;

-- 패널간 거리
BCF_SPACING = 15;

-- 최근강조패널
BCF_LASTCRITPANEL = 1;

-- 강조패널 y값
BCF_CRITPANEL_Y = 40;

-- 강조패널 +offset값
BCF_CRIT_X_OFFSET = 80;
BCF_CRIT_Y_OFFSET = 30;

-- 패널 객체
BCF_Objects = {};

BCF_UseEvents = {
	["PLAYER_REGEN_ENABLED"] = 1,
	["PLAYER_REGEN_DISABLED"] = 1,
	["UNIT_HEALTH"] = 1,
	["UNIT_MANA"] = 1,
	["COMBAT_TEXT_UPDATE"] = 1,
};

function BCF_Print(msg)
	if ( Blink and Blink.Utils and Blink.Utils.Print ) then
		Blink.Utils.Print(msg);
	else
		ChatFrame1:AddMessage(msg, 1.0, 1.0, 0.2);
	end
end

function BCF_DebugPrint(msg)
	if ( debug~=true ) then
		return;
	end
	if ( not msg ) then
		msg = "-nil-";
	end
	msg = "BCF Debug>> "..msg;
	if ( Blink and Blink.Utils and Blink.Utils.Print ) then
		Blink.Utils.Print(msg);
	else
		ChatFrame1:AddMessage(msg, 1.0, 0.6, 0.2);
	end
end

function BCF_SavedReset()
	BlinkCombatFeed_Data = {};
	BlinkCombatFeed_Color_Data = {};
	
	for key,value in pairs(BlinkCombatFeed_Default) do
		BlinkCombatFeed_Data[key] = value;
	end
	for key,value in pairs(BlinkCombatFeed_Color_Default) do
		BlinkCombatFeed_Color_Data[key] = value;
	end
end


-------------------------------------------------------------------------------

-- OnLoad
function BlinkCombatFeedback_OnLoad()
	
	this:RegisterEvent("VARIABLES_LOADED");

	--setglobal("PERIODICAURADAMAGESELFOTHER", "%1$s|1이;가; 당신의 %4$s에 의해 %2$d의 %3$s 피해를 입었습니다.");
	--setglobal("SPELLRESISTSELFOTHER" , "당신은 %s|1으로;로; %s|1을;를; 공격했지만 저항했습니다.");
	--setglobal("PERIODICAURAHEALSELFSELF" , "당신은 자신의 %2$s|1으로;로; 인해 생명력이 %1$d만큼 회복되었습니다.");
	--setglobal("PROCRESISTSELFOTHER" , "%s|1이;가; 당신의 %s|1을;를; 저항했습니다.");

	SLASH_BCFOPTION1 = "/bcf";
	SLASH_BCFOPTION2 = "/전투메세지";
	SLASH_BCFOPTION3 = "/블컴";
	SLASH_BCFOPTION4 = "/피드백";
	SlashCmdList["BCFOPTION"] = function (msg)
		BCF_SlashCommand(msg);
	end;
end

-- OnEvent 이벤트 핸들러
function BlinkCombatFeedback_OnEvent(event)
	if ( event == "VARIABLES_LOADED" ) then
		if ( not BlinkCombatFeed_Data or not BlinkCombatFeed_Data["VERSION"] or BlinkCombatFeed_Data["VERSION"] < BCF_VERSION_N ) then
			BCF_Print("BCF First Loaded.");
			BCF_SavedReset();
		end

		for e, v in pairs(BCF_UseEvents) do
			BlinkCombatFeedbackFrame:RegisterEvent(e);
		end

		if ( BlinkCombatFeedback_Custom and type(BlinkCombatFeedback_Custom)=='table' ) then
			BCF_RegisterDefaultEvents();
			for e, handler in pairs(BlinkCombatFeedback_Custom) do
				if ( not BCF_UseEvents[e] and e~="VARIABLES_LOADED" ) then
					BlinkCombatFeedbackFrame:RegisterEvent(e);
				end
			end
		end

		BlinkCombatFeedbackFrame:UnregisterEvent("VARIABLES_LOADED");

		local _,filename = UnitClass("player");
		if ( string.upper(filename) == "ROGUE" or string.upper(filename) == "DRUID" ) then
			BlinkCombatFeedbackFrame:RegisterEvent("PLAYER_COMBO_POINTS");
		end

		BCF_RegisterMenu();
		BCF_RegisterBlinkGUIMenu();
		BCF_RemoveAllPanels();
		return;
	end

	if ( BCF_GetOption("ENABLE") ~= 1 ) then
		return;
	end

	-- events
	if ( event == "COMBAT_TEXT_UPDATE" ) then
		BlinkCombatFeedback_OnCombatTextEvent(arg1, arg2, arg3);
		return;
	elseif ( event == "PLAYER_REGEN_ENABLED" ) then
		if ( BCF_GetOption("SHOWINOUTCOMBAT") == 1 ) then
			BCF_DisplayMessage({
				text = "전투 종료",
				fontheight = BCF_GetOption("FONTSIZE"),
				rgb = BCF_GetColor("INOUTCOMBAT"),
				paneltype = "standard"
			});
		end
		return;
	elseif ( event == "PLAYER_REGEN_DISABLED" ) then
		if ( BCF_GetOption("SHOWINOUTCOMBAT") == 1 ) then
			BCF_DisplayMessage({
				text = "전투 시작",
				fontheight = BCF_GetOption("FONTSIZE"),
				rgb = BCF_GetColor("INOUTCOMBAT"),
				paneltype = "standard"
			});
		end
		return;
	elseif ( event == "PLAYER_COMBO_POINTS" and BCF_GetOption("SHOWCOMBO") == 1 ) then
		local combo = GetComboPoints();
		if( combo > 0 )then
			local fs = BCF_GetOption("FONTSIZE");
			fs = fs * 1.25;
			if ( combo >= 5 ) then
				fs = fs * 1.25;
			end
			combo = combo .. " 콤보";
			BCF_DisplayMessage({
				text = combo,
				fontheight = fs,
				rgb = BCF_GetColor("COMBO"),
				paneltype = "crit"
			});
		end
	elseif ( event == "UNIT_HEALTH" and arg1 == "player" and BCF_GetOption("SHOWLOWHEALTH") == 1 ) then
		local warnlevel = BCF_GetOption("LOWHEALTHVALUE");
		if ( UnitHealth("player")/UnitHealthMax("player") < warnlevel ) then
			if ( not BlinkCombatFeedbackFrame.lowHealth ) then
				BCF_DisplayMessage({
					text = "[체력 "..(warnlevel*100).."%경고("..UnitHealth("player")..")]",
					fontheight = BCF_GetOption("FONTSIZE"),
					rgb = BCF_GetColor("LOWHEALTH"),
					paneltype = "sticky",
					font = "Fonts\\2002b.TTF",
					outline = ""
				});
				BlinkCombatFeedbackFrame.lowHealth = 1;
			end
		else
			BlinkCombatFeedbackFrame.lowHealth = nil;
		end
		return;
	elseif ( event == "UNIT_MANA" and arg1 == "player" and BCF_GetOption("SHOWLOWMANA") == 1 and UnitPowerType("player") == 0 ) then
		local mana = UnitMana("player");
		local warnlevel = BCF_GetOption("LOWMANAVALUE");
		if ( mana/UnitManaMax("player") < warnlevel ) then
			if ( not BlinkCombatFeedbackFrame.lowMana ) then
				BCF_DisplayMessage({
					text = "[마나 "..(warnlevel*100).."%경고("..UnitMana("player")..")]",
					fontheight = BCF_GetOption("FONTSIZE"),
					rgb = BCF_GetColor("LOWMANA"),
					paneltype = "sticky",
					font = "Fonts\\2002b.TTF",
					outline = ""
				});
				BlinkCombatFeedbackFrame.lowMana = 1;
			end
		else
			BlinkCombatFeedbackFrame.lowMana = nil;
		end
		return;
	end

	-- custom events
	if ( BCF_GetOption("USECUSTOMEVENT") == 1 ) then
		BCF_CustomEventHandler(event,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9);
	end
end

-- 패널 애니메이션 컨트롤
function BCF_updateAnimation(elapsed)
	local anyActive = false;
	for index, panel in pairs(BCF_Objects) do
		if ( panel:IsShown() ) then
			anyActive = true;
			BCF_DrawPanel(panel);
		end
	end
	if ((anyActive ~= true) and (BlinkCombatFeedbackFrame:IsVisible())) then
		BlinkCombatFeedbackFrame:Hide();
	end
end

-- 패널 움직이기
function BCF_DrawPanel(panel)
	if ( panel.scrollFunction and type(panel.scrollFunction) == 'function' ) then
		panel.scrollFunction(panel);
	else
		if ( panel.paneltype and BCF_ScrollFunctions[panel.paneltype] ) then
			BCF_ScrollFunctions[panel.paneltype]:scroll(panel);
		else
			BCF_ScrollFunctions["standard"]:scroll(panel);
		end
	end
end

-- 빈 패널 찾기
function BCF_FindIdlePanel()
	local panel;
	for i=1, BCF_MAX_PANEL do
		panel = getglobal("BCFPanel"..i);
		if ( not panel:IsShown() ) then
			return panel;
		end 
	end
	return BCF_GetOldestPanel(),1;
end

-- 가장오래된 패널 찾기
function BCF_GetOldestPanel()
	local oldestPanel = BCF_Objects[1];
	BCF_RemovePanel(oldestPanel);
	return oldestPanel;
end

-- 패널 초기화
function BCF_RemovePanel(panel)
	for index, value in pairs(BCF_Objects) do
		if ( value == panel ) then
			tremove(BCF_Objects, index);
			panel:SetAlpha(0);
			panel:Hide();
			panel:SetPoint("CENTER", "BCF_Message_Knob", "CENTER", 0, 0 );
			break;
		end
	end
end

-- 모든패널 초기화
function BCF_RemoveAllPanels()
	for i=1, BCF_MAX_PANEL do
		panel = getglobal("BCFPanel"..i);
		BCF_RemovePanel(panel);
	end
end

function BCF_GetPanelCount(paneltype)
	local count = 0;
	for index, panel in pairs(BCF_Objects) do
		if ( panel.paneltype == paneltype ) then
			count = count + 1;
		end
	end
	return count;
end

-- 출력메세지 추가 : info table
function BCF_DisplayMessage(info)
	if ( not info ) then
		return;
	end
	if ( not info.text or info.text == '' ) then
		return;
	end
	if ( info.r and info.g and info.b ) then
		info.rgb = { r = info.r, g = info.g, b = info.b };
		info.r = nil;
		info.g = nil;
		info.b = nil;
	end
	BCF_DisplayCombatMessage(
		info.text,
		info.fontheight,
		info.rgb,
		nil,
		nil,
		info.paneltype,
		info.font,
		info.outline,
		info.isStaggered,
		info.scrollFunction,
		info.anchor
	);
end

-- 메세지 패널보이기
function BCF_DisplayCombatMessage(text,fontheight,r,g,b,paneltype,font,outline,isStaggered,scrollFunction,anchor)
	-- 메세지 보이기 옵션 여부
	if ( BCF_GetOption("HIDEMSG") == 1 ) then
		return;
	end

	-- 패널 인스턴스
	local panel, noPanelsAvailable = BCF_FindIdlePanel();
	if ( noPanelsAvailable ) then
		-- 비어있는 패널이 없다??
		return;
	end

	-- 패널색상
	local rr,gg,bb;
	if (r) and type(r) == 'table' then
		rr = r.r;
		gg = r.g;
		bb = r.b;
	end
	if r and g and b then
		rr = r;
		gg = g;
		bb = b;
	end

	if ( not fontheight ) then
		fontheight = BCF_GetOption("FONTSIZE");
	end

	-- 패널타입
	if ( not paneltype ) then
		panel.paneltype = "standard";
	else
		panel.paneltype = string.lower(paneltype);
	end

	-- 패널타입에 따른 스크롤함수 지정
	if ( scrollFunction and type(scrollFunction) == 'function' ) then
		panel.scrollFunction = scrollFunction;
	end

	-- 패널 시작 시간
	panel.startTime = GetTime();

	-- 패널 폰트 설정
	panel.fontheight = fontheight;
	if ( not font ) then font = "Fonts\\K_Damage.TTF"; end
	if ( not outline ) then outline = ""; end

	-- Stagger the text if flagged
	local staggerAmount = 0;
	if ( isStaggered ) then
		staggerAmount = random(0, BCF_PANEL_STAGGER_RANGE) - BCF_PANEL_STAGGER_RANGE/2;
	end

	-- 패널 앵커
	if ( not anchor ) then
		panel.anchor = "BCF_Message_Knob";
	elseif ( not getglobal(anchor) ) then
		panel.anchor = "BCF_Message_Knob";
	else
		panel.anchor = anchor;
	end

	-- 패널 초기 위치
	panel.xPos = staggerAmount;
	panel.yPos = 0;
	panel.alter = 0;

	-- 이전 패널과 너무가까우면 위치를 조절한다.
	if (panel.paneltype and BCF_ScrollFunctions[panel.paneltype] and BCF_ScrollFunctions[panel.paneltype].updatePosition ) then
		BCF_ScrollFunctions[panel.paneltype]:updatePosition(panel);
	end

	-- 애드온 Showing
	if (not BlinkCombatFeedbackFrame:IsVisible()) then
		BlinkCombatFeedbackFrame:Show();
	end

	-- 패널 셋팅
	panel:SetFont(font, fontheight, outline);
	panel:SetTextColor(rr, gg, bb);
	panel:SetText(text);
	panel:SetPoint("CENTER", panel.anchor, "CENTER", panel.xPos, panel.yPos );
	panel:SetAlpha(0);
	panel:Show();
	tinsert(BCF_Objects, panel);
end

-- 사용자정의 이벤트 핸들러
function BCF_CustomEventHandler(event,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9)
	local events = BlinkCombatFeedback_Custom[event];
	local fontheight = BCF_GetOption("FONTSIZE");
	local rgb = { r=1.0, g=1.0, b=1.0 };
	local class = UnitClass("player");
	local exc = false;
	local enable = true;
	local event_cnt = 0;
	local event_exec_cnt = 0;
	if ( events ) then
		for idx, handler in pairs(events) do
			event_cnt = event_cnt + 1;
			exc = false;
			enable = true;

			-- 실행여부?
			if ( handler.commandkey and BCF_GetOption(handler.commandkey) ~= 1 ) then
				enable = false;
			end

			if ( enable == true ) then
				event_exec_cnt = event_exec_cnt + 1;

				-- 지정된 직업이 있는가?
				if ( handler.class ) then
					if ( type(handler.class)=='string' ) then
						if ( class == handler.class ) then
							exc = true;
						end
					elseif ( type(handler.class)=='table' ) then
						for _,c in pairs(handler.class) do
							if ( class == c ) then
								exc = true;
							end
						end
					end
				else
					if ( handler.classcallback and type(handler.classcallback)=='table' ) then
						for cls,callback in pairs(handler.classcallback) do
							if ( cls == class ) then
								exc = true;
							end
						end
					else
						exc = true;
					end
				end

				if ( exc == true ) then

					if ( handler.pattern ) then
						for a1,a2,a3,a4,a5,a6,a7,a8,a9 in string.gmatch( arg1, handler.pattern ) do

							local _callback_result1_,_callback_result2_;
							local showmsg = handler.showmsg;

							-- 지정된 콜백함수가 있는가?
							if ( handler.callback and type(handler.callback)=="function" ) then
								_callback_result1_ = handler.callback(event,arg1,a1,a2,a3,a4,a5,a6,a7,a8,a9);
							end

							-- 직업특화 콜백함수가 있는가?
							if ( handler.classcallback and type(handler.classcallback)=='table' ) then
								if ( handler.classcallback[class] and type(handler.classcallback[class])=='function' ) then
									_callback_result2_ = handler.classcallback[class](event,arg1,a1,a2,a3,a4,a5,a6,a7,a8,a9);
								end
							end

							if ( showmsg == 2 ) then
								if ( _callback_result1_ or _callback_result2_ ) then
									showmsg = 1;
								else
									showmsg = 0;
								end
							end

							if ( (not showmsg or showmsg==1) and handler.msg ) then
								if ( handler.fontheight and type(handler.fontheight)=='number' ) then
									fontheight = handler.fontheight;
								end
								if ( handler.rgb and handler.rgb.r and handler.rgb.b and handler.rgb.b ) then
									rgb.r = handler.rgb.r; rgb.g = handler.rgb.g; rgb.b = handler.rgb.b;
								end
								local msg = handler.msg;
								if ( a1 ) then msg = string.gsub(msg, "%%1", a1); end
								if ( a2 ) then msg = string.gsub(msg, "%%2", a2); end
								if ( a3 ) then msg = string.gsub(msg, "%%3", a3); end
								if ( a4 ) then msg = string.gsub(msg, "%%4", a4); end
								if ( a5 ) then msg = string.gsub(msg, "%%5", a5); end
								if ( a6 ) then msg = string.gsub(msg, "%%6", a6); end
								if ( a7 ) then msg = string.gsub(msg, "%%7", a7); end
								if ( a8 ) then msg = string.gsub(msg, "%%8", a8); end
								if ( a9 ) then msg = string.gsub(msg, "%%9", a9); end

								-- 메세지패널 보이기
								--BCF_DisplayCombatMessage(msg, fontheight, rgb.r, rgb.g, rgb.b, handler.isCrit,handler.font, handler.outline);
								BCF_DisplayMessage({
									text = msg,
									fontheight = fontheight,
									rgb = rgb,
									paneltype = handler.paneltype,
									font = handler.font,
									outline = handler.outline,
									isStaggered = handler.isStaggered,
									scrollFunction = handler.scrollFunction,
									anchor = handler.anchor
								});
							end

							-- 지정된 사운드 파일이 있는가?
							if ( handler.soundfile ) then
								PlaySoundFile(handler.soundfile); -- ex) PlaySoundFile("Interface\\AddOns\\BlinkCombatFeedback\\sound\\"..handler.soundfile);
							end

							-- 지정된 사운드효과가 있는가?
							if ( handler.sound ) then
								PlaySound(handler.sound); -- ex) PlaySound("AuctionWindowClose");
							end
						end
					else
						local _callback_result1_,_callback_result2_;
						local showmsg = handler.showmsg;

						-- 지정된 콜백함수가 있는가?
						if ( handler.callback and type(handler.callback)=="function" ) then
							_callback_result1_ = handler.callback(event,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9);
						end

						-- 직업특화 콜백함수가 있는가?
						if ( handler.classcallback and type(handler.classcallback)=='table' ) then
							if ( handler.classcallback[class] and type(handler.classcallback[class])=='function' ) then
								_callback_result2_ = handler.classcallback[class](event,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9);
							end
						end

						if ( showmsg == 2 ) then
							if ( _callback_result1_ or _callback_result2_ ) then
								showmsg = 1;
							else
								showmsg = 0;
							end
						end

						if ( (not showmsg or showmsg==1) and handler.msg ) then
							if ( handler.fontheight and type(handler.fontheight)=='number' ) then
								fontheight = handler.fontheight;
							end
							if ( handler.rgb and handler.rgb.r and handler.rgb.b and handler.rgb.b ) then
								rgb.r = handler.rgb.r; rgb.g = handler.rgb.g; rgb.b = handler.rgb.b;
							end
							local msg = handler.msg;

							-- 메세지패널 보이기
							--BCF_DisplayCombatMessage(msg, fontheight, rgb.r, rgb.g, rgb.b, handler.isCrit);
							BCF_DisplayMessage({
								text = msg,
								fontheight = fontheight,
								rgb = rgb,
								paneltype = handler.paneltype,
								font = handler.font,
								outline = handler.outline,
								isStaggered = handler.isStaggered,
								scrollFunction = handler.scrollFunction
							});
						end

						-- 지정된 사운드 파일이 있는가?
						if ( handler.soundfile ) then
							PlaySoundFile(handler.soundfile);
						end

						-- 지정된 사운드효과가 있는가?
						if ( handler.sound ) then
							PlaySound(handler.sound);
						end
					end
				end
			end
		end
		BCF_DebugPrint(event.." Event...");
		BCF_DebugPrint("event parser count = "..event_cnt);
		BCF_DebugPrint("event executed = "..event_exec_cnt);
	end
end

-- /명령어
function BCF_SlashCommand(msg)
	local cmd = gsub(msg, "%s*([^%s]+).*", "%1");
	local opt = gsub(msg, "%s*([^%s]+)%s*(.*)", "%2");

	if(strlen(cmd) <= 0) then
		BCF_DisplayHelp();
	else
		if ( cmd == "enable" or cmd == "사용" ) then
			BCF_SetOption("ENABLE", 1);
			BCF_DisplayOneOption("ENABLE");
		elseif ( cmd == "disable" or cmd == "사용안함" ) then
			BCF_SetOption("ENABLE", 0);
			BCF_DisplayOneOption("ENABLE");
		elseif ( cmd == "토글" ) then
			local r = BCF_GetOption("ENABLE");
			if ( r == 1 ) then
				BCF_SetOption("ENABLE", 0);
			else
				BCF_SetOption("ENABLE", 1);
			end
			BCF_DisplayOneOption("ENABLE");
		elseif cmd == "spelltype" or cmd == "데미지속성" then
			local r = BCF_GetOption("SHOWSPELLSCHOOL");
			if ( r == 1 ) then
				BCF_SetOption("SHOWSPELLSCHOOL",0);
			else
				BCF_SetOption("SHOWSPELLSCHOOL",1);
			end
			BCF_DisplayOneOption("SHOWSPELLSCHOOL");
		elseif cmd == "show" or cmd == "보이기" then
			BCF_SetOption("HIDEMSG", 0);
			BCF_DisplayOneOption("HIDEMSG");
		elseif cmd == "hide" or cmd == "감추기" then
			BCF_SetOption("HIDEMSG", 1);
			BCF_DisplayOneOption("HIDEMSG");
		elseif cmd == "lock" or cmd == "고정" then
			local knob = getglobal("BCF_Message_Knob");
			knob:Hide();
			BCF_DisplayOneOption("LOCK");
		elseif cmd == "unlock" or cmd == "이동" then
			local knob = getglobal("BCF_Message_Knob");
			knob:Show();
			BCF_DisplayOneOption("UNLOCK");
		elseif cmd == "combo" or cmd == "연계" then
			local r = BCF_GetOption("SHOWCOMBO");
			if ( r == 1 ) then
				BCF_SetOption("SHOWCOMBO", 0);
			else
				BCF_SetOption("SHOWCOMBO", 1);
			end
			BCF_DisplayOneOption("SHOWCOMBO");
		elseif cmd == "damage" or cmd == "피해" then
			local r = BCF_GetOption("SHOWDAMAGE");
			if ( r == 1 ) then
				BCF_SetOption("SHOWDAMAGE", 0);
			else
				BCF_SetOption("SHOWDAMAGE", 1);
			end
			BCF_DisplayOneOption("SHOWDAMAGE");
--		elseif cmd == "physicaldamage" or cmd == "물리피해" then
--			local r = BCF_GetOption("SHOWDAMAGEPHYSICAL");
--			if ( r == 1 ) then
--				BCF_SetOption("SHOWDAMAGEPHYSICAL", 0);
--			else
--				BCF_SetOption("SHOWDAMAGEPHYSICAL", 1);
--			end
--			BCF_DisplayOneOption("SHOWDAMAGE");
--		elseif cmd == "spelldamage" or cmd == "마법피해" then
--			local r = BCF_GetOption("SHOWDAMAGESPELL");
--			if ( r == 1 ) then
--				BCF_SetOption("SHOWDAMAGESPELL", 0);
--			else
--				BCF_SetOption("SHOWDAMAGESPELL", 1);
--			end
--			BCF_DisplayOneOption("SHOWDAMAGE");
		elseif cmd == "combat" or cmd == "전투시작" then
			local r = BCF_GetOption("SHOWINOUTCOMBAT");
			if ( r == 1 ) then
				BCF_SetOption("SHOWINOUTCOMBAT", 0);
			else
				BCF_SetOption("SHOWINOUTCOMBAT", 1);
			end
			BCF_DisplayOneOption("SHOWINOUTCOMBAT");
		elseif cmd == "direction" or cmd == "방향" then
			local r = BCF_GetOption("DIRECTION");
			if ( r == 1 ) then
				BCF_SetOption("DIRECTION", 0);
			else
				BCF_SetOption("DIRECTION", 1);
			end
			BCF_DisplayOneOption("DIRECTION");
		elseif cmd == "up" or cmd == "위로" then
			BCF_SetOption("DIRECTION", 0);
			BCF_DisplayOneOption("DIRECTION");
		elseif cmd == "down" or cmd == "아래로" then
			BCF_SetOption("DIRECTION", 1);
			BCF_DisplayOneOption("DIRECTION");
		elseif cmd == "custom" or cmd == "사용자정의" then
			local r = BCF_GetOption("USECUSTOMEVENT");
			if ( r == 1 ) then
				BCF_SetOption("USECUSTOMEVENT", 0);
			else
				BCF_SetOption("USECUSTOMEVENT", 1);
			end
			BCF_DisplayOneOption("USECUSTOMEVENT");
		elseif (cmd == "fontsize" or cmd == "fontheight" or cmd == "글자크기" ) then
			if opt ~= nil and strlen(opt)>0 then
				local fs = tonumber(opt);
				if ( type(fs) == 'number' ) then
					BCF_SetOption("FONTSIZE", fs);
					BCF_DisplayOneOption("FONTSIZE");
				else
					BCF_Print("사용방법: /bcf 글자크기 [크기]. 예) /bcf 글자크기 20");
					return;
				end
			else
				BCF_Print("사용방법: /bcf 글자크기 [크기]. 예) /bcf 글자크기 20");
				return;
			end
		else
			if ( BlinkCombatFeedback_Custom_Commands ) then
				for key,command in pairs(BlinkCombatFeedback_Custom_Commands) do
					if ( command.cmd and command.cmdfunc and type(command.cmdfunc)=='function' ) then
						if ( type(command.cmd)=='string' ) then
							if ( cmd == command.cmd ) then
								command.cmdfunc();
								BCF_DisplayOneOption(key);
							end
						elseif ( type(command.cmd) == 'table' ) then
							for _,c in pairs(command.cmd) do
								if ( cmd == c ) then
									command.cmdfunc();
									BCF_DisplayOneOption(key);
								end
							end
						end
					end
				end
			end
		end
--		BCF_DisplayOption();
	end
end

function BCF_DisplayHelp()
	BCF_Print("블링크의 전투 메세지 "..BCF_VERSION.." - 02/15(20003)");
	BCF_Print(" /bcf : 기능을 활성화/비활성화 및 도움말 표시");
	BCF_Print(" /bcf 토글 : 기능을 활성화/비활성화 및 도움말 표시");
	BCF_Print(" /bcf 보이기 : 전투메세지를 보입니다.");
	BCF_Print(" /bcf 감추기 : 전투메세지를 감춥니다.");
	BCF_Print(" /bcf 글자크기 [크기]: 메세지의 글자크기를 지정");
	BCF_Print(" /bcf 보고: 전투종료후 전투결과를 보여줌/안보여줌");
	BCF_Print(" /bcf 회복: 체력 회복 수치를 보여줍니다.");
	BCF_Print(" /bcf 피해: 피해 수치를 보여줍니다.");
	BCF_Print("    /bcf 물리피해: 물리피해 수치를 보여줍니다.");
	BCF_Print("    /bcf 마법피해: 마법피해 수치를 보여줍니다.");
	BCF_Print(" /bcf 연계: 도적/드루이드의 연계포인트를 보여줌/안보여줌");
	BCF_Print(" /bcf 전투시작: 전투시작 및 전투종료 메세지를 보여줌/안보여줌");
	BCF_Print(" /bcf 방향|위로|아래로: 메세지의 스크롤방향을 바꿉니다.");
	BCF_Print(" /bcf 고정|이동: 출력되는 메세지의 위치를 조정할수있도록합니다.");
	BCF_Print(" /bcf 데미지속성: 받은 데이지의 속성을 표시/해제합니다.");
	BCF_Print(" /bcf 사용자정의: 사용자정의 이벤트를 실행함/실행안함");
	if ( BlinkCombatFeedback_Custom_Commands ) then
		for key,command in pairs(BlinkCombatFeedback_Custom_Commands) do
			if ( command.cmd and command.helpmsg ) then
				if ( type(command.cmd)=='string' ) then
					BCF_Print(" /bcf "..string.format(command,helpmsg,"|cff00ff00"..command.cmd.."|r"));
				elseif ( type(command.cmd) == 'table' ) then
					local cmds = "";
					for _,c in pairs(command.cmd) do
						if ( c~="" ) then
							cmds = cmds .. "||" .. "|cff00ff00"..c.."|r";
						end
					end
					cmds = string.sub(cmds,3);
					BCF_Print(" /bcf "..string.format(command.helpmsg,cmds));
				end
			end
		end
	end
	BCF_DisplayOption();
end

function BCF_DisplayOption()
	if ( BCF_GetOption("ENABLE") == 1 ) then
		BCF_Print(" 전투 메세지 : |cff00ff00활성화|r");
	else
		BCF_Print(" 전투 메세지 : |cffff0f00비활성화|r");
	end
	if ( BCF_GetOption("HIDEMSG") == 1 ) then
		BCF_Print(" 전투 메세지 : |cffff0f00숨김|r");
	end
--	if ( BCF_GetOption("SHOWHEAL") == 1 ) then
--		BCF_Print(" 회복 : |cff00ff00활성화|r");
--	else
--		BCF_Print(" 회복 : |cffff0f00비활성화|r");
--	end
	if ( BCF_GetOption("SHOWDAMAGE") == 1 ) then
		BCF_Print(" 피해 메세지 : |cff00ff00활성화|r");
--		if ( BCF_GetOption("SHOWDAMAGEPHYSICAL") == 1 ) then
--			BCF_Print(" 물리피해 : |cff00ff00활성화|r");
--		else
--			BCF_Print(" 물리피해 : |cffff0f00비활성화|r");
--		end
--		if ( BCF_GetOption("SHOWDAMAGESPELL") == 1 ) then
--			BCF_Print(" 마법피해 : |cff00ff00활성화|r");
--		else
--			BCF_Print(" 마법피해 : |cffff0f00비활성화|r");
--		end
	else
		BCF_Print(" 피해 메세지 : |cffff0f00비활성화|r");
	end
	if ( BCF_GetOption("SHOWCOMBO") == 1 ) then
		BCF_Print(" 연계포인트 : |cff00ff00활성화|r");
	else
		BCF_Print(" 연계포인트 : |cffff0f00비활성화|r");
	end
	if ( BCF_GetOption("SHOWINOUTCOMBAT") == 1 ) then
		BCF_Print(" 전투시작 : |cff00ff00활성화|r");
	else
		BCF_Print(" 전투시작 : |cffff0f00비활성화|r");
	end
	if ( BCF_GetOption("SHOWSPELLSCHOOL") == 1 ) then
		BCF_Print(" 데미지속성 : |cff00ff00표시|r");
	else
		BCF_Print(" 데미지속성 : |cffff0f00표시안함|r");
	end
	if ( BCF_GetOption("DIRECTION") == 1 ) then
		BCF_Print(" 메세지방향 : |cff00ff00아래로|r");
	else
		BCF_Print(" 메세지방향 : |cff00ff00위로|r");
	end
	local knob = getglobal("BCF_Message_Knob");
	if ( knob:IsVisible() ) then
		BCF_Print(" 위치조정 : |cff00ff00이동가능|r");
	else
		BCF_Print(" 위치조정 : |cffff0f00고정됨|r");
	end
	if ( BCF_GetOption("USECUSTOMEVENT") == 1 ) then
		BCF_Print(" 사용자정의 이벤트 : |cff00ff00활성화|r");
	else
		BCF_Print(" 사용자정의 이벤트 : |cffff0f00비활성화|r");
	end
	BCF_Print(" 메세지 글자크기 : |cff00ff00" .. BCF_GetOption("FONTSIZE").." 픽셀|r");

	if ( BlinkCombatFeedback_Custom_Commands ) then
		for key,command in pairs(BlinkCombatFeedback_Custom_Commands) do
			if ( command.cmd and command.statusmsg ) then
				if ( BCF_GetOption(key) == 1 ) then
					BCF_Print(string.format(command.statusmsg,"|cff00ff00활성화|r"));
				else
					BCF_Print(string.format(command.statusmsg,"|cffff0f00비활성화|r"));
				end
			end
		end
	end
end


function BCF_DisplayOneOption(key)
	--key = string.upper(key);
	if ( key == "ENABLE" or key == "HIDEMSG" ) then
		if ( BCF_GetOption("ENABLE") == 1 ) then
			BCF_Print(" 전투 메세지 : |cff00ff00활성화|r");
		else
			BCF_Print(" 전투 메세지 : |cffff0f00비활성화|r");
		end
		if ( BCF_GetOption("HIDEMSG") == 1 ) then
			BCF_Print(" 전투 메세지 : |cffff0f00숨김|r");
		end
	elseif ( key == "SHOWDAMAGE" ) then
		if ( BCF_GetOption("SHOWDAMAGE") == 1 ) then
			BCF_Print(" 피해 메세지 : |cff00ff00활성화|r");
--			if ( BCF_GetOption("SHOWDAMAGEPHYSICAL") == 1 ) then
--				BCF_Print(" 물리피해 : |cff00ff00활성화|r");
--			else
--				BCF_Print(" 물리피해 : |cffff0f00비활성화|r");
--			end
--			if ( BCF_GetOption("SHOWDAMAGESPELL") == 1 ) then
--				BCF_Print(" 마법피해 : |cff00ff00활성화|r");
--			else
--				BCF_Print(" 마법피해 : |cffff0f00비활성화|r");
--			end
		else
			BCF_Print(" 피해 메세지 : |cffff0f00비활성화|r");
		end
	elseif ( key == "SHOWCOMBO" ) then
		if ( BCF_GetOption("SHOWCOMBO") == 1 ) then
			BCF_Print(" 연계포인트 : |cff00ff00활성화|r");
		else
			BCF_Print(" 연계포인트 : |cffff0f00비활성화|r");
		end
	elseif ( key == "SHOWINOUTCOMBAT" ) then
		if ( BCF_GetOption("SHOWINOUTCOMBAT") == 1 ) then
			BCF_Print(" 전투시작&종료 : |cff00ff00활성화|r");
		else
			BCF_Print(" 전투시작&종료 : |cffff0f00비활성화|r");
		end
	elseif ( key == "SHOWSPELLSCHOOL" ) then
		if ( BCF_GetOption("SHOWSPELLSCHOOL") == 1 ) then
			BCF_Print(" 데미지속성 : |cff00ff00표시|r");
		else
			BCF_Print(" 데미지속성 : |cffff0f00표시안함|r");
		end
	elseif ( key == "DIRECTION" ) then
		if ( BCF_GetOption("DIRECTION") == 1 ) then
			BCF_Print(" 메세지방향 : |cff00ff00아래로|r");
		else
			BCF_Print(" 메세지방향 : |cff00ff00위로|r");
		end
	elseif ( key == "LOCK" or key == "UNLOCK" ) then
		local knob = getglobal("BCF_Message_Knob");
		if ( knob:IsVisible() ) then
			BCF_Print(" 위치조정 : |cff00ff00이동가능|r");
		else
			BCF_Print(" 위치조정 : |cffff0f00고정됨|r");
		end
	elseif ( key == "USECUSTOMEVENT" ) then
		if ( BCF_GetOption("USECUSTOMEVENT") == 1 ) then
			BCF_Print(" 사용자정의 이벤트 : |cff00ff00활성화|r");
		else
			BCF_Print(" 사용자정의 이벤트 : |cffff0f00비활성화|r");
		end
	elseif ( key == "FONTSIZE" ) then
		BCF_Print(" 메세지 글자크기 : |cff00ff00" .. BCF_GetOption("FONTSIZE").." 픽셀|r");
	else
		if ( BlinkCombatFeedback_Custom_Commands and BlinkCombatFeedback_Custom_Commands[key] ) then
			if ( BlinkCombatFeedback_Custom_Commands[key].cmd and BlinkCombatFeedback_Custom_Commands[key].statusmsg ) then
				if ( BCF_GetOption(key) == 1 ) then
					BCF_Print(string.format(BlinkCombatFeedback_Custom_Commands[key].statusmsg,"|cff00ff00활성화|r"));
				else
					BCF_Print(string.format(BlinkCombatFeedback_Custom_Commands[key].statusmsg,"|cffff0f00비활성화|r"));
				end
			end
		end
	end
end

-- 옵션 설정
function BCF_SetOption(key,value)
	if ( not key or key == "" ) then
		return;
	end
	if ( not BlinkCombatFeed_Data or not BlinkCombatFeed_Data["VERSION"] or BlinkCombatFeed_Data["VERSION"] < BCF_VERSION_N ) then
		BCF_SavedReset();
	end
	BlinkCombatFeed_Data[key] = value;
end

-- 옵션 불러오기
function BCF_GetOption(key)
	if ( not key or key == "" ) then
		return nil;
	end
	if ( not BlinkCombatFeed_Data or not BlinkCombatFeed_Data["VERSION"] or BlinkCombatFeed_Data["VERSION"] < BCF_VERSION_N ) then
		BCF_SavedReset();
	end
	if ( BlinkCombatFeed_Data[key] ) then
		return BlinkCombatFeed_Data[key];
	else
		if BlinkCombatFeed_Default[key] then
			BlinkCombatFeed_Data[key] = BlinkCombatFeed_Default[key];
			return BlinkCombatFeed_Data[key];
		else
			return nil;
		end
	end
end

-- 색상 설정
function BCF_SetColor(key,value)
	if ( not key or key == "" ) then
		return;
	end
	if ( not value or type(value)~='table') then
		value = { r=1.0, g=1.0,b=1.0 };
	end
	if ( not BlinkCombatFeed_Color_Data ) then
		BlinkCombatFeed_Color_Data = {};
		for k,v in pairs(BlinkCombatFeed_Color_Default) do
			BlinkCombatFeed_Color_Data[k] = v;
		end
	end
	BlinkCombatFeed_Color_Data[key] = value;
end

-- 색상 불러오기
function BCF_GetColor(key)
	if ( not key or key == "" ) then
		return nil;
	end
	if ( not BlinkCombatFeed_Color_Data ) then
		BlinkCombatFeed_Color_Data = {};
		for k,v in pairs(BlinkCombatFeed_Color_Default) do
			BlinkCombatFeed_Color_Data[k] = v;
		end
	end
	if ( BlinkCombatFeed_Color_Data[key] ) then
		return BlinkCombatFeed_Color_Data[key];
	elseif ( BlinkCombatFeed_Color_Default[key] ) then
		BlinkCombatFeed_Color_Data[key] = BlinkCombatFeed_Color_Default[key];
		return BlinkCombatFeed_Color_Data[key];
	else
		return { r=1.0, g=1.0, b=1.0 };
	end
end
-------------------------------------------------------------------------------
