
local activeSpellSound = {
	["반격"] = "Interface\\AddOns\\BlinkCombatFeedback\\sound\\Roar.wav",
};

local ignoreLoseSpells = {
	-- warrior
	["방어 태세"] = 1,
	["전투 태세"] = 1,
	["광폭 태세"] = 1,
	-- mage
	["점멸"] = 1,
};

function BlinkCombatFeedback_OnCombatTextEvent(action, data, value)

	local text,rgb,paneltype,fontheight;
	if ( action == "SPELL_ACTIVE" and BCF_GetOption("SHOWSPELLACTIVE") == 1 ) then
		if ( data == "제압" ) then
			return; -- 전사 제압은 제외 시킴(전태아니면 작동을 안해서-_-)
		end
		if ( activeSpellSound[data] ) then
			PlaySoundFile(activeSpellSound[data]);
		end
		BCF_DisplayMessage({
			text = "<"..data..">",
			fontheight = BCF_GetOption("FONTSIZE"),
			rgb = BCF_GetColor("SPELLACTIVE"),
			paneltype = "sticky",
			font = "Fonts\\2002b.TTF",
			outline = "OUTLINE",
		});
	elseif ( action == "FACTION" ) then
		if ( tonumber(value) < 0 and BCF_GetOption("SHOWREPUTATIONDOWN") == 1 ) then
			BCF_DisplayMessage({
				text = data.." "..REPUTATION.." "..value,
				fontheight = BCF_GetOption("FONTSIZE"),
				rgb = BCF_GetColor("LOSTREPUT"),
				paneltype = "x2",
				font = "Fonts\\2002b.TTF",
			});
		elseif ( tonumber(value) >= 0 and BCF_GetOption("SHOWREPUTATIONUP") == 1 ) then
			BCF_DisplayMessage({
				text = data.." "..REPUTATION.." +"..value,
				fontheight = BCF_GetOption("FONTSIZE"),
				rgb = BCF_GetColor("GAINREPUT"),
				paneltype = "x2",
				font = "Fonts\\2002b.TTF",
			});
			-- show or not?
			if ( BCF_GetOption("SHOWAUTOREPUTATION") == 1 ) then
				local watchedName = GetWatchedFactionInfo();
				if ( not watchedName or (watchedName and watchedName ~= data) ) then
					local numFactions = GetNumFactions();
					for i=1, numFactions, 1 do
						local factionName = GetFactionInfo(i);
						if ( factionName == data ) then
							SetWatchedFactionIndex(i);
							break;
						end
					end
				end
			end
		end
	elseif ( action == "HONOR_GAINED" and BCF_GetOption("SHOWHONOR") == 1 ) then
		BCF_DisplayMessage({
			text = "+"..data.." 명예점수",
			fontheight = BCF_GetOption("FONTSIZE"),
			rgb = BCF_GetColor("GAINHONOR"),
			font = "Fonts\\2002b.TTF",
			paneltype = "x2",
		});
	elseif ( action == "AURA_END" and BCF_GetOption("SHOWBUFFING") == 1 ) then
		if ( not ignoreLoseSpells[data] ) then
			BCF_DisplayMessage({
				text = "-("..data..")",
				fontheight = BCF_GetOption("FONTSIZE"),
				font = "Fonts\\2002b.TTF",
				outline = "OUTLINE",
				rgb = {r=0.95,g=0.95,b=0.25},
				paneltype = "standard",
			});
		end
	elseif ( action == "AURA_END_HARMFUL" and BCF_GetOption("SHOWDEBUFFING") == 1 ) then
		if ( not ignoreLoseSpells[data] ) then
			BCF_DisplayMessage({
				text = "-["..data.."]",
				fontheight = BCF_GetOption("FONTSIZE"),
				font = "Fonts\\2002b.TTF",
				outline = "OUTLINE",
				rgb = {r=0.95,g=0.25,b=0.25},
				paneltype = "standard",
			});
		end
	elseif ( action == "EXTRA_ATTACKS" and BCF_GetOption("SHOWDOUBLEHIT") == 1 ) then
		BCF_DisplayMessage({
			text = data.."회 추가타",
			rgb = BCF_GetColor("DOUBLEHIT"),
			fontheight = BCF_GetOption("FONTSIZE") * 1.25,
			font = "Fonts\\2002b.TTF",
			outline = "OUTLINE",
			paneltype = "gravity",
		});

--	elseif ( action == "MANA" and BCF_GetOption("SHOWGAINPOWER") == 1 ) then
--		if ( tonumber(data) > 0 ) then
--			data = "+"..data;
--		end
--		BCF_DisplayMessage({
--			text = data.." "..MANA,
--			rgb = BCF_GetColor("GAINPOWER"),
--			fontheight = BCF_GetOption("FONTSIZE"),
--			paneltype = "fountain",
--		});
--	elseif ( action == "RAGE" and BCF_GetOption("SHOWGAINPOWER") == 1 ) then
--		BCF_DisplayMessage({
--			text = "+"..data.." "..RAGE,
--			rgb = BCF_GetColor("GAINPOWER"),
--			fontheight = BCF_GetOption("FONTSIZE"),
--			paneltype = "fountain",
--		});
--	elseif ( action == "ENERGY" and BCF_GetOption("SHOWGAINPOWER") == 1 ) then
--		BCF_DisplayMessage({
--			text = "+"..data.." "..ENERGY,
--			rgb = BCF_GetColor("GAINPOWER"),
--			fontheight = BCF_GetOption("FONTSIZE"),
--			paneltype = "fountain",
--		});
--	elseif ( action == "FOCUS" and BCF_GetOption("SHOWGAINPOWER") == 1 ) then
--		BCF_DisplayMessage({
--			text = "+"..data.." "..FOCUS,
--			rgb = BCF_GetColor("GAINPOWER"),
--			fontheight = BCF_GetOption("FONTSIZE"),
--			paneltype = "fountain",
--		});
	elseif ( action == "ENCHANTMENT_ADDED" and BCF_GetOption("SHOWBUFFING") == 1 ) then
		BCF_DisplayMessage({
			text = "+("..data..")",
			fontheight = BCF_GetOption("FONTSIZE"),
			font = "Fonts\\2002b.TTF",
			outline = "OUTLINE",
			rgb = {r=0.95,g=0.95,b=0.25},
			paneltype = "gravity",
		});
	elseif ( action == "ENCHANTMENT_REMOVED" and BCF_GetOption("SHOWBUFFING") == 1 ) then
		BCF_DisplayMessage({
			text = "-("..data..")",
			fontheight = BCF_GetOption("FONTSIZE"),
			font = "Fonts\\2002b.TTF",
			outline = "OUTLINE",
			rgb = {r=0.95,g=0.95,b=0.25},
			paneltype = "gravity",
		});
	end

	if ( BCF_GetOption("SHOWDEFENSE") == 1 ) then
		fontheight = BCF_GetOption("FONTSIZE");
		paneltype = "x2";
		if ( (action == "BLOCK" or action == "SPELL_BLOCKED") and BCF_GetOption("SHOWBLOCK") == 1 ) then
			if ( value ) then
				-- Partial block
				-- text = data.." "..format(BLOCK_TRAILER, value);
				return;
			else
				text = BLOCK;
			end
			rgb = BCF_GetColor("BLOCK");
			fontheight = BCF_GetOption("FONTSIZE") * 0.9;
		elseif ( (action == "ABSORB" or action == "SPELL_ABSORBED") and BCF_GetOption("SHOWABSORB") == 1 ) then
			if ( value ) then
				-- Partial block
				-- text = data.." "..format(ABSORB_TRAILER, value);
				return;
			else
				text = ABSORB;
			end
			rgb = BCF_GetColor("ABSORB");
			fontheight = BCF_GetOption("FONTSIZE") * 0.9;
		elseif ( (action == "RESIST" or action == "SPELL_RESISTED") and BCF_GetOption("SHOWRESIST") == 1 ) then
			if ( value ) then
				-- Partial resist
				-- text = data.." "..format(RESIST_TRAILER, value);
				return;
			else
				text = RESIST;
			end
			rgb = BCF_GetColor("RESIST");
			fontheight = BCF_GetOption("FONTSIZE") * 0.9;
		elseif ( action == "PROC_RESISTED" and BCF_GetOption("SHOWRESIST") == 1 ) then
			text = data;
			rgb = BCF_GetColor("RESIST");
		elseif ( (action == "MISS" or action == "SPELL_MISSED") and BCF_GetOption("SHOWMISS") == 1 ) then
			text = MISS;
			rgb = BCF_GetColor("MISS");
		elseif ( (action == "EVADE" or action == "SPELL_EVADED") and BCF_GetOption("SHOWEVADE") == 1 ) then
			text = EVADE;
			rgb = BCF_GetColor("EVADE");
		elseif ( (action == "DODGE" or action == "SPELL_DODGED") and BCF_GetOption("SHOWDODGE") == 1 ) then
			text = DODGE;
			rgb = BCF_GetColor("DODGE");
		elseif ( (action == "PARRY" or action == "SPELL_PARRIED") and BCF_GetOption("SHOWPARRY") == 1 ) then
			text = PARRY;
			rgb = BCF_GetColor("PARRY");
		elseif ( (action == "IMMUNE" or action == "SPELL_IMMUNE") and BCF_GetOption("SHOWIMMUNE") == 1 ) then
			text = IMMUNE;
			rgb = BCF_GetColor("IMMUNE");
		elseif ( (action == "DEFLECT" or action == "SPELL_DEFLECTED") and BCF_GetOption("SHOWDEFLECT") == 1 ) then
			text = DEFLECT;
			rgb = BCF_GetColor("DEFLECT");
		end
		BCF_DisplayMessage({
			text = text,
			rgb = rgb,
			fontheight = fontheight,
			paneltype = paneltype,
		});
	end
end
