
--[[

* 스킬데미지
스킬에 의한 치명상 데미지
스킬에 의한 데미지
스킬에 의한 속성 극대화 데미지
스킬에 의한 속성 데미지

* 평타
치명상 데미지
데미지
(마법봉) 속성 데미지
(마법봉) 속성 극대화 데미지
(자동사격) 치명상 데미지
(자동사격) 데미지

* dot
NPC에게 스킬에 의한 속성 데미지 - 지속성
적플레이어에게 스킬에 의한 속성 데미지 - 지속성
반사 데미지

* 스킬실패
스킬 방어
스킬 빗맞음
스킬 피함
스킬 빗나감
스킬 면역
스킬 흡수
스킬 MISS
스킬 막음
스킬 반사
스킬 저항

* 평타실패
MISS
흡수
방어
빗맞음
피함
빗나감
면역
막음
반사
저항

* 소환수공격
소환수의 데미지
소환수의 치명타 데미지
소환수의 스킬 속성 데미지
소환수의 스킬 속성 극대화 데미지
소환수의 스킬 데미지
소환수의 스킬 치명타 데미지

* 특수
평정사격 빗나감
도발 저항
도발의 일격 저항

]]


function BlinkCombatFeedback_General_OnLoad()
	BCFG_Damage_Record = {target = "",damage = 0,spell = "",time = 0,};
	this:RegisterEvent("VARIABLES_LOADED");
end

function BlinkCombatFeedback_General_OnEvent(event)
	if ( event == "VARIABLES_LOADED" ) then
		this:UnregisterEvent("VARIABLES_LOADED");
		BCFG_RegisterAll();
		BCFG_RegisterMenu();
	end
end

function BCFG_IsBestDamage(damage,target,spell)
	if ( damage and tonumber(damage) > 0 ) then
		if ( BCFG_Damage_Record.damage < tonumber(damage) ) then
			BCFG_SaveBestDamageRecord(damage,target,spell);
			return true;
		end
	end
	return false;
end

function BCFG_SaveBestDamageRecord(damage,target,spell)
	if ( damage and tonumber(damage) > 0 ) then
		BCFG_Damage_Record = {
			target = target,
			damage = tonumber(damage),
			spell = spell,
			time = GetTime()
		};
	end
end

function BCFG_RegisterAll()
	if ( not BCF_Register ) then
		return;
	end

---------------------------
-- CHAT_MSG_SPELL_SELF_BUFF
---------------------------

------------------------------------
-- CHAT_MSG_SPELL_HOSTILEPLAYER_BUFF
------------------------------------

-----------------------------
-- CHAT_MSG_SPELL_SELF_DAMAGE
-----------------------------

	-- 스킬에 의한 치명타 메세지 - 0205
	BCF_Register({
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+)|1으로;로; (.+)에게 (%d+)의 치명상 피해를 입혔습니다.",
		callback = function (event,msg,spell,target,damage)
			if ( BCFG_IsBestDamage(damage,target,spell) == true ) then
				BCF_DisplayMessage({
					text = "NEW Record!! |cFF33FF33"..spell.."|r : |cFFFF0000"..damage.."|r",
					fontheight = BCF_GetOption("FONTSIZE") * 1.5,
					rgb = {r=0.8,g=0.8,b=0.1},
					paneltype = "sticky",
					font = "Fonts\\2002b.TTF",
					anchor = "BCFG_Message_Knob",
				});
				PlaySound("LEVELUP", 1, 1, 0, 1, 3);
				if ( BCF_GetOption("NEWRECORDSHOT") == 1 ) then
					TakeScreenshot();
				end
			else
				local suffix = BCF_FindSuffix(msg);
				local text;
				if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
					text = spell.." : "..damage..suffix;
				else
					text = damage..suffix;
				end
				BCF_DisplayMessage({
					text = text,
					fontheight = BCF_GetOption("FONTSIZE") * 1.25,
					rgb = BCF_GetColor("ENEMYSPELLDAMAGE"),
					paneltype = "crit",
					anchor = "BCFG_Message_Knob",
				});
			end
		end,
		commandkey = "SHOWCRITHIT",
		command = {
			title = "치명타 메세지",
			cmd = {"치명타","crithit"},
			helpmsg = "%s: 적에게 입힌 치명타 데미지를 표시합니다.",
			statusmsg = " 치명타 메세지 : %s",
			cmdfunc = function ()
				local r = BCF_GetOption("SHOWCRITHIT");
				if ( r == 1 ) then
					BCF_SetOption("SHOWCRITHIT", 0);
				else
					BCF_SetOption("SHOWCRITHIT", 1);
				end
			end,
		},
	});

	-- 스킬에 의한 평타 데미지 - 0205
	BCF_Register({
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+)|1으로;로; (.+)에게 (%d+)의 피해를 입혔습니다.",
		callback = function (event,msg,spell,target,damage)
			if ( BCFG_IsBestDamage(damage,target,spell) == true ) then
				BCF_DisplayMessage({
					text = "NEW Record!! |cFF33FF33"..spell.."|r : |cFFFF0000"..damage.."|r",
					fontheight = BCF_GetOption("FONTSIZE") * 1.5,
					rgb = {r=0.8,g=0.8,b=0.1},
					paneltype = "sticky",
					font = "Fonts\\2002b.TTF",
					anchor = "BCFG_Message_Knob",
				});
				PlaySound("LEVELUP", 1, 1, 0, 1, 3);
				if ( BCF_GetOption("NEWRECORDSHOT") == 1 ) then
					TakeScreenshot();
				end
			else
				local suffix = BCF_FindSuffix(msg);
				local text;
				if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
					text = spell.." : "..damage..suffix;
				else
					text = damage..suffix;
				end
				BCF_DisplayMessage({
					text = text,
					fontheight = BCF_GetOption("FONTSIZE"),
					rgb = BCF_GetColor("ENEMYSPELLDAMAGE"),
					paneltype = "gravity",
					anchor = "BCFG_Message_Knob",
				});
			end
		end,
		commandkey = "SHOWNORMALHIT",
		command = {
			title = "평타 메세지",
			cmd = {"평타","normalhit"},
			helpmsg = "%s: 적에게 입힌 평타 데미지를 표시합니다.",
			statusmsg = " 평타 메세지 : %s",
			cmdfunc = function ()
				local r = BCF_GetOption("SHOWNORMALHIT");
				if ( r == 1 ) then
					BCF_SetOption("SHOWNORMALHIT", 0);
				else
					BCF_SetOption("SHOWNORMALHIT", 1);
				end
			end,
		},
	});

	-- 스펠에 의한 극대화 메세지(데미지속성표시) - 물리,신성,화염,냉기,암흑,자연 등 - 0205
	BCF_Register({
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+)|1으로;로; (.+)에게 (%d+)의 ([신성|화염|자연|냉기|암흑|비전|물리]+) 치명상 피해를 입혔습니다.",
		callback = function (event,msg,spell,target,damage,dtype)
			if ( BCFG_IsBestDamage(damage,target,spell) == true ) then
				BCF_DisplayMessage({
					text = "NEW Record!! |cFF33FF33"..spell.."|r : |cFFFF0000"..damage.."|r",
					fontheight = BCF_GetOption("FONTSIZE") * 1.5,
					rgb = {r=0.8,g=0.8,b=0.1},
					paneltype = "sticky",
					font = "Fonts\\2002b.TTF",
					anchor = "BCFG_Message_Knob",
				});
				PlaySound("LEVELUP", 1, 1, 0, 1, 3);
				if ( BCF_GetOption("NEWRECORDSHOT") == 1 ) then
					TakeScreenshot();
				end
			else
				local suffix = BCF_FindSuffix(msg);
				local text;
				local rgb;
				if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
					if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
						text = spell.." : "..damage..suffix;
					else
						text = spell.."("..dtype..") : "..damage..suffix;
					end
				else
					text = damage..suffix;
				end
				if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
					if ( dtype == "신성" ) then
						rgb = BCF_GetColor("Holy");
					elseif ( dtype == "화염" ) then
						rgb = BCF_GetColor("Fire");
					elseif ( dtype == "자연" ) then
						rgb = BCF_GetColor("Nature");
					elseif ( dtype == "냉기" ) then
						rgb = BCF_GetColor("Frost");
					elseif ( dtype == "암흑" ) then
						rgb = BCF_GetColor("Shadow");
					elseif ( dtype == "비전" ) then
						rgb = BCF_GetColor("Arcane");
					else
						rgb = BCF_GetColor("ENEMYSPELLDAMAGE");
					end
				else
					rgb = BCF_GetColor("ENEMYSPELLDAMAGE");
				end
				BCF_DisplayMessage({
					text = text,
					fontheight = BCF_GetOption("FONTSIZE") * 1.25,
					rgb = rgb,
					paneltype = "crit",
					anchor = "BCFG_Message_Knob",
				});
			end
		end,
		commandkey = "SHOWCRITHIT",
	});

	-- 스펠에 의한 평타 메세지 - 0205
	BCF_Register({
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+)|1으로;로; (.+)에게 (%d+)의 ([신성|화염|자연|냉기|암흑|비전|물리]+) 피해를 입혔습니다.",
		callback = function (event,msg,spell,target,damage,dtype)
			if ( BCFG_IsBestDamage(damage,target,spell) == true ) then
				BCF_DisplayMessage({
					text = "NEW Record!! |cFF33FF33"..spell.."|r : |cFFFF0000"..damage.."|r",
					fontheight = BCF_GetOption("FONTSIZE") * 1.5,
					rgb = {r=0.8,g=0.8,b=0.1},
					paneltype = "sticky",
					font = "Fonts\\2002b.TTF",
					anchor = "BCFG_Message_Knob",
				});
				PlaySound("LEVELUP", 1, 1, 0, 1, 3);
				if ( BCF_GetOption("NEWRECORDSHOT") == 1 ) then
					TakeScreenshot();
				end
			else
				local suffix = BCF_FindSuffix(msg);
				local text;
				local rgb;
				if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
					if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
						text = spell.." : "..damage..suffix;
					else
						text = spell.."("..dtype..") : "..damage..suffix;
					end
				else
					text = damage..suffix;
				end
				if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
					if ( dtype == "신성" ) then
						rgb = BCF_GetColor("Holy");
					elseif ( dtype == "화염" ) then
						rgb = BCF_GetColor("Fire");
					elseif ( dtype == "자연" ) then
						rgb = BCF_GetColor("Nature");
					elseif ( dtype == "냉기" ) then
						rgb = BCF_GetColor("Frost");
					elseif ( dtype == "암흑" ) then
						rgb = BCF_GetColor("Shadow");
					elseif ( dtype == "비전" ) then
						rgb = BCF_GetColor("Arcane");
					else
						rgb = BCF_GetColor("ENEMYSPELLDAMAGE");
					end
				else
					rgb = BCF_GetColor("ENEMYSPELLDAMAGE");
				end
				BCF_DisplayMessage({
					text = text,
					fontheight = BCF_GetOption("FONTSIZE"),
					rgb = rgb,
					paneltype = "gravity",
					anchor = "BCFG_Message_Knob",
				});
			end
		end,
		commandkey = "SHOWNORMALHIT",
	});

	-- 각종 스킬 실패관련
	BCF_Register({ -- 0208
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+)|1으로;로; (.+)|1을;를; 공격했지만 방어했습니다.$",
		msg = "%1 "..BLOCK,
		rgb = BCF_GetColor("BLOCK"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0208
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+)|1으로;로; (.+)|1을;를; 공격했지만 빗맞았습니다.$",
		msg = "%1 "..DEFLECT,
		rgb = BCF_GetColor("DEFLECT"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0208
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+)|1으로;로; (.+)|1을;를; 공격했지만 교묘히 피했습니다.$",
		msg = "%1 "..DODGE,
		rgb = BCF_GetColor("DODGE"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0208
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+)|1으로;로; (.+)|1을;를; 공격했지만 빗나갔습니다.$",
		msg = "%1 "..EVADE,
		rgb = BCF_GetColor("EVADE"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0208
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+) 사용에 실패했습니다. (.+)|1은;는; 면역입니다.$",
		msg = "%1 "..IMMUNE,
		rgb = BCF_GetColor("IMMUNE"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0208
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "(.+)|1이;가; 당신의 (.+)|1을;를; 흡수했습니다.$",
		msg = "%2 "..ABSORB,
		rgb = BCF_GetColor("ABSORB"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0208
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+)|1으로;로; (.+)|1을;를; 공격했지만 적중하지 않았습니다.$",
		msg = "%1 "..MISS,
		rgb = BCF_GetColor("MISS"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0208
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+)|1으로;로; (.+)|1을;를; 공격했지만 막았습니다.$",
		msg = "%1 "..PARRY,
		rgb = BCF_GetColor("PARRY"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0208
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+)|1으로;로; (.+)|1을;를; 공격했지만 반사했습니다.$",
		msg = "%1 "..REFLECT,
		rgb = BCF_GetColor("REFLECT"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0208
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 (.+)|1으로;로; (.+)|1을;를; 공격했지만 저항했습니다.",
		msg = "%1 "..RESIST,
		rgb = BCF_GetColor("RESIST"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0205
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "(.+)|1이;가; 당신의 (.+)|1을;를; 저항했습니다.",
		msg = "%2 "..RESIST,
		rgb = BCF_GetColor("RESIST"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	-- 평정 빗나감
	BCF_Register({
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 평정의 사격|1으로;로; (.+)|1을;를; 공격했지만 적중하지 않았습니다.",
		msg = "평정 MISS!",
		class = "사냥꾼",
		font = "Fonts\\2002b.TTF",
		rgb = {r=0.8, g=0.3, b=0.55},
		fontheight = BCF_GetOption("FONTSIZE") * 1.25,
		paneltype = "sticky",
		anchor = "BCFG_Message_Knob",
		callback = function (event,msg,target)
			if ( BCF_GetOption("ANNOUNCETQSHOTMISS") == 1 ) then
				SendChatMessage(">>> "..target.." <<< 평정의 사격 빗나감!!!!!", "YELL");
			end
		end,
		commandkey = "ANNOUNCETQSHOTMISS",
		command = {
			title = "평정사격 빗나감 알림",
			cmd = {"평정사격","tqshot"},
			helpmsg = "%s: 평정의 사격이 빗나갈경우 외침으로 주변에 알려줍니다.",
			statusmsg = " 평정사격 빗나감 알림 : %s",
			cmdfunc = function ()
				local r = BCF_GetOption("ANNOUNCETQSHOTMISS");
				if ( r == 1 ) then
					BCF_SetOption("ANNOUNCETQSHOTMISS", 0);
				else
					BCF_SetOption("ANNOUNCETQSHOTMISS", 1);
				end
			end,
			default = 1,
		},
	});

	-- 도발 저항 : 전사
	BCF_Register({
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 도발|1으로;로; (.+)|1을;를; 공격했지만 저항했습니다.",
		msg = "%1 : 도발저항!",
		class = "전사",
		font = "Fonts\\2002b.TTF",
		rgb = {r=0.8, g=0.3, b=0.55},
		paneltype = "sticky",
		anchor = "BCFG_Message_Knob",
		fontheight = BCF_GetOption("FONTSIZE") * 1.25,
		callback = function (event,msg,target)
			if ( BCF_GetOption("ANNOUNCETAUNTRESIST") == 1 ) then
				SendChatMessage(">>> "..target.." <<< 도발 저항!!!!!", "YELL");
			end
		end,
		commandkey = "ANNOUNCETAUNTRESIST",
		command = {
			title = "도발저항 알림",
			cmd = {"도발저항","taunt"},
			helpmsg = "%s: 도발 또는 도발의 일격을 저항할 경우 외침으로 주변에 알려줍니다.",
			statusmsg = " 도발 저항 알림 : %s",
			cmdfunc = function ()
				local r = BCF_GetOption("ANNOUNCETAUNTRESIST");
				if ( r == 1 ) then
					BCF_SetOption("ANNOUNCETAUNTRESIST", 0);
				else
					BCF_SetOption("ANNOUNCETAUNTRESIST", 1);
				end
			end,
			default = 1,
		},
	});

	-- 정의의 방어 저항 : 성기사
	BCF_Register({
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 정의의 방어|1으로;로; (.+)|1을;를; 공격했지만 저항했습니다.",
		msg = "%1 : 정의의 방어 저항!",
		class = "성기사",
		font = "Fonts\\2002b.TTF",
		rgb = {r=0.8, g=0.3, b=0.55},
		paneltype = "sticky",
		anchor = "BCFG_Message_Knob",
		fontheight = BCF_GetOption("FONTSIZE") * 1.25,
		callback = function (event,msg,target)
			if ( BCF_GetOption("ANNOUNCETAUNTRESIST") == 1 ) then
				SendChatMessage(">>> "..target.." <<< 정의의 방어 저항!!!!!", "YELL");
			end
		end,
		commandkey = "ANNOUNCETAUNTRESIST",		
	});

	-- 포효 저항 : 드루이드
	BCF_Register({
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 포효|1으로;로; (.+)|1을;를; 공격했지만 저항했습니다.",
		msg = "%1 : 포효 저항!",
		class = "드루이드",
		font = "Fonts\\2002b.TTF",
		rgb = {r=0.8, g=0.3, b=0.55},
		paneltype = "sticky",
		anchor = "BCFG_Message_Knob",
		fontheight = BCF_GetOption("FONTSIZE") * 1.25,
		callback = function (event,msg,target)
			if ( BCF_GetOption("ANNOUNCETAUNTRESIST") == 1 ) then
				SendChatMessage(">>> "..target.." <<< 포효 저항!!!!!", "YELL");
			end
		end,
		commandkey = "ANNOUNCETAUNTRESIST",		
	});

	-- 도발의 일격 저항 : 전사
	BCF_Register({
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 도발의 일격|1으로;로; (.+)|1을;를; 공격했지만 막았습니다.",
		msg = "%1 : 도발의 일격 저항!",
		class = "전사",
		font = "Fonts\\2002b.TTF",
		rgb = {r=0.8, g=0.3, b=0.55},
		paneltype = "sticky",
		anchor = "BCFG_Message_Knob",
		fontheight = BCF_GetOption("FONTSIZE") * 1.25,
		callback = function (event,msg,target)
			if ( BCF_GetOption("ANNOUNCETAUNTRESIST") == 1 ) then
				SendChatMessage(">>> "..target.." <<< 도발의 일격 저항!!!!!", "YELL");
			end
		end,
		commandkey = "ANNOUNCETAUNTRESIST",
	});

	-- 유혹 저항 : 흑마법사 - 써큐버스
	BCF_Register({
		event = "CHAT_MSG_SPELL_PET_DAMAGE",
		pattern = "(.+)|1이;가; 유혹|1으로;로; (.+)|1을;를; 공격했지만 저항했습니다.",
		commandkey = "ANNOUNCETAUNTRESIST",
		callback = function (event,msg,pet,target)
			local petname = UnitName("pet");
			local text;
			text = ">>> "..target.." <<< 유혹 저항!!!!!";
			if petname == pet then
				if ( BCF_GetOption("ANNOUNCETAUNTRESIST") == 1 ) then
					if ( GetNumPartyMembers() ~= 0 ) or ( GetNumRaidMembers() ~= 0 )then
						SendChatMessage(text, "YELL");
					else
						DEFAULT_CHAT_FRAME:AddMessage(text);
					end
				end
			end
			BCF_DisplayMessage({
				class = "흑마법사",
				text = "%2 : 유혹 저항!",
				fontheight = BCF_GetOption("FONTSIZE") * 1.25,
				rgb = {r=0.8, g=0.3, b=0.55},
				paneltype = "sticky",
				anchor = "BCFG_Message_Knob",
				font = "Fonts\\2002b.TTF",
				isStaggered = 1,
			});
		end,
	});

	-- 언데드 속박 저항 : 사제
	BCF_Register({
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 언데드 속박|1으로;로; (.+)|1을;를; 공격했지만 저항했습니다.",
		msg = "%1 : 언데드 속박 저항!",
		class = "사제",
		font = "Fonts\\2002b.TTF",
		rgb = {r=0.8, g=0.3, b=0.55},
		paneltype = "sticky",
		anchor = "BCFG_Message_Knob",
		fontheight = BCF_GetOption("FONTSIZE") * 1.25,
		callback = function (event,msg,target)
			local text;
			text = ">>> "..target.." <<< 언데드 속박 저항!!!!!";
			if ( BCF_GetOption("ANNOUNCETAUNTRESIST") == 1 ) then
				if ( GetNumPartyMembers() ~= 0 ) or ( GetNumRaidMembers() ~= 0 )then
					SendChatMessage(text, "YELL");
				else
					DEFAULT_CHAT_FRAME:AddMessage(text);
				end
			end
		end,
		commandkey = "ANNOUNCETAUNTRESIST",
	});

	-- 얼음의 덫 저항 : 사냥꾼
	BCF_Register({
		event = "CHAT_MSG_SPELL_PET_DAMAGE",
		pattern = "(.+)|1이;가; 얼음의 덫|1으로;로; (.+)|1을;를; 공격했지만 저항했습니다.",
		msg = "%1 : 얼음의 덫 저항!",
		class = "사냥꾼",
		font = "Fonts\\2002b.TTF",
		rgb = {r=0.8, g=0.3, b=0.55},
		paneltype = "sticky",
		anchor = "BCFG_Message_Knob",
		fontheight = BCF_GetOption("FONTSIZE") * 1.25,
		callback = function (event,msg,pet,target)
			local text;
			text = ">>> "..target.." <<< 얼음의 덫 저항!!!!!";
			if ( BCF_GetOption("ANNOUNCETAUNTRESIST") == 1 ) then
				if ( GetNumPartyMembers() ~= 0 ) or ( GetNumRaidMembers() ~= 0 )then
					SendChatMessage(text, "YELL");
				else
					DEFAULT_CHAT_FRAME:AddMessage(text);
				end
			end
		end,
		commandkey = "ANNOUNCETAUNTRESIST",
	});

	-- 변이 저항 : 마법사
	BCF_Register({
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 변이|1으로;로; (.+)|1을;를; 공격했지만 저항했습니다.",
		msg = "%1 : 변이 저항!",
		class = "마법사",
		font = "Fonts\\2002b.TTF",
		rgb = {r=0.8, g=0.3, b=0.55},
		paneltype = "sticky",
		anchor = "BCFG_Message_Knob",
		fontheight = BCF_GetOption("FONTSIZE") * 1.25,
		callback = function (event,msg,target)
			local text;
			text = ">>> "..target.." <<< 변이 저항!!!!!";
			if ( BCF_GetOption("ANNOUNCETAUNTRESIST") == 1 ) then
				if ( GetNumPartyMembers() ~= 0 ) or ( GetNumRaidMembers() ~= 0 )then
					SendChatMessage(text, "YELL");
				else
					DEFAULT_CHAT_FRAME:AddMessage(text);
				end
			end
		end,
		commandkey = "ANNOUNCETAUNTRESIST",
	});

	-- 죽은척하기 : 사냥꾼
	BCF_Register({
		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
		pattern = "당신은 죽은척하기|1으로;로; (.+)|1을;를; 공격했지만 저항했습니다.",
		msg = "%1 : 죽은척하기 저항!",
		class = "사냥꾼",
		font = "Fonts\\2002b.TTF",
		rgb = {r=0.8, g=0.3, b=0.55},
		paneltype = "sticky",
		anchor = "BCFG_Message_Knob",
		fontheight = BCF_GetOption("FONTSIZE") * 1.25,		
		commandkey = "ANNOUNCETAUNTRESIST",
	});

--	-- 충격의 일격 저항
--	BCF_Register({
--		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
--		pattern = "충격의 일격|1으로;로; (.+)|1을;를; 공격했지만 피해를 입지 않았습니다.",
--		msg = "%1 : 충격의 일격 저항!",
--		class = "전사",
--		font = "Fonts\\2002b.TTF",
--		rgb = {r=0.8, g=0.3, b=0.55},
--		paneltype = "sticky",
--		anchor = "BCFG_Message_Knob",
--		fontheight = BCF_GetOption("FONTSIZE") * 1.25,
--		callback = function (event,msg,target)
--			if ( BCF_GetOption("ANNOUNCESTUNMISS") == 1 ) then
--				SendChatMessage(">>> "..target.." <<< 충격의 일격 저항!!!!!", "YELL");
--			end
--		end,
--		commandkey = "ANNOUNCESTUNMISS",
--		command = {
--			title = "충격의일격 저항 알림",
--			cmd = {"충격저항","stunmiss"},
--			helpmsg = "%s: 충격의 일격을 저항할 경우 외침으로 주변에 알려줍니다.",
--			statusmsg = " 충격의 일격 저항 알림 : %s",
--			cmdfunc = function ()
--				local r = BCF_GetOption("ANNOUNCESTUNMISS");
--				if ( r == 1 ) then
--					BCF_SetOption("ANNOUNCESTUNMISS", 0);
--				else
--					BCF_SetOption("ANNOUNCESTUNMISS", 1);
--				end
--			end,
--			default = 1,
--		},
--	});
--
--	-- 충격의 일격 저항2
--	BCF_Register({
--		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
--		pattern = "충격의 일격|1으로;로; (.+)|1을;를; 공격했지만 교묘히 피했습니다.",
--		msg = "%1 : 충격의 일격 저항!",
--		class = "전사",
--		font = "Fonts\\2002b.TTF",
--		rgb = {r=0.8, g=0.3, b=0.55},
--		paneltype = "sticky",
--		anchor = "BCFG_Message_Knob",
--		fontheight = BCF_GetOption("FONTSIZE") * 1.25,
--		callback = function (event,msg,target)
--			if ( BCF_GetOption("ANNOUNCESTUNMISS") == 1 ) then
--				SendChatMessage(">>> "..target.." <<< 충격의 일격 저항!!!!!", "YELL");
--			end
--		end,
--		commandkey = "ANNOUNCESTUNMISS",
--	});
--
--	-- 충격의 일격 저항3
--	BCF_Register({
--		event = "CHAT_MSG_SPELL_SELF_DAMAGE",
--		pattern = "(.+)에게 사용한 충격의 일격|1이;가; 빗나갔습니다.",
--		msg = "%1 : 충격의 일격 저항!",
--		class = "전사",
--		font = "Fonts\\2002b.TTF",
--		rgb = {r=0.8, g=0.3, b=0.55},
--		paneltype = "sticky",
--		anchor = "BCFG_Message_Knob",
--		fontheight = BCF_GetOption("FONTSIZE") * 1.25,
--		callback = function (event,msg,target)
--			if ( BCF_GetOption("ANNOUNCESTUNMISS") == 1 ) then
--				SendChatMessage(">>> "..target.." <<< 충격의 일격 저항!!!!!", "YELL");
--			end
--		end,
--		commandkey = "ANNOUNCESTUNMISS",
--	});


----------------------------
-- CHAT_MSG_COMBAT_SELF_HITS
----------------------------

	-- 마법봉 평타
	BCF_Register({
		event = "CHAT_MSG_COMBAT_SELF_HITS",
		pattern = "당신은 (.+)|1으로;로; (.+)에게 (%d+)의 ([신성|화염|자연|냉기|암흑|비전|물리]+) 피해를 입혔습니다.",
		callback = function (event,msg,spell,target,damage,dtype)
			local suffix = BCF_FindSuffix(msg);
			local text;
			local rgb;
			if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
				text = damage..suffix;
				if ( dtype == "신성" ) then
					rgb = BCF_GetColor("Holy");
				elseif ( dtype == "화염" ) then
					rgb = BCF_GetColor("Fire");
				elseif ( dtype == "자연" ) then
					rgb = BCF_GetColor("Nature");
				elseif ( dtype == "냉기" ) then
					rgb = BCF_GetColor("Frost");
				elseif ( dtype == "암흑" ) then
					rgb = BCF_GetColor("Shadow");
				elseif ( dtype == "비전" ) then
					rgb = BCF_GetColor("Arcane");
				else
					rgb = BCF_GetColor("ENEMYNORMALDAMAGE");
				end
			else
				text = damage.."("..dtype..") : "..suffix;
				rgb = BCF_GetColor("ENEMYNORMALDAMAGE");
			end			
			BCF_DisplayMessage({
				text = text,
				fontheight = BCF_GetOption("FONTSIZE"),
				rgb = rgb,
				paneltype = "gravity",
				anchor = "BCFG_Message_Knob",
			});
		end,
		commandkey = "SHOWNORMALHIT",
	});

	-- 마법봉 치명타
	BCF_Register({
		event = "CHAT_MSG_COMBAT_SELF_HITS",
		pattern = "당신은 (.+)|1으로;로; (.+)에게 (%d+)의 ([신성|화염|자연|냉기|암흑|비전|물리]+) 치명상 피해를 입혔습니다.",
		callback = function (event,msg,spell,target,damage,dtype)
			local suffix = BCF_FindSuffix(msg);
			local text;
			local rgb;
			if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
				text = damage..suffix;
				if ( dtype == "신성" ) then
					rgb = BCF_GetColor("Holy");
				elseif ( dtype == "화염" ) then
					rgb = BCF_GetColor("Fire");
				elseif ( dtype == "자연" ) then
					rgb = BCF_GetColor("Nature");
				elseif ( dtype == "냉기" ) then
					rgb = BCF_GetColor("Frost");
				elseif ( dtype == "암흑" ) then
					rgb = BCF_GetColor("Shadow");
				elseif ( dtype == "비전" ) then
					rgb = BCF_GetColor("Arcane");
				else
					rgb = BCF_GetColor("ENEMYNORMALDAMAGE");
				end
			else
				text = damage.."("..dtype..") : "..suffix;
				rgb = BCF_GetColor("ENEMYNORMALDAMAGE");
			end			
			BCF_DisplayMessage({
				text = text,
				fontheight = BCF_GetOption("FONTSIZE") * 1.25,
				rgb = rgb,
				paneltype = "crit",
				anchor = "BCFG_Message_Knob",
			});
		end,
		commandkey = "SHOWCRITHIT",
	});

	-- 일반공격 치명타 데미지 - 0205
	BCF_Register({
		event = "CHAT_MSG_COMBAT_SELF_HITS",
		pattern = "당신은 (.+)|1을;를; 공격하여 (%d+)의 치명상 피해를 입혔습니다.",
		callback = function (event,msg,target,damage)
			if ( BCFG_IsBestDamage(damage,target,"평타") == true ) then
				BCF_DisplayMessage({
					text = "NEW Record!! |cFF33FF33".."평타".."|r : |cFFFF0000"..damage.."|r",
					fontheight = BCF_GetOption("FONTSIZE") * 1.5,
					rgb = {r=0.8,g=0.8,b=0.1},
					paneltype = "sticky",
					font = "Fonts\\2002b.TTF",
				});
				PlaySound("LEVELUP", 1, 1, 0, 1, 3);
				if ( BCF_GetOption("NEWRECORDSHOT") == 1 ) then
					TakeScreenshot();
				end
			else
				local suffix = BCF_FindSuffix(msg);
				BCF_DisplayMessage({
					text = damage..suffix,
					rgb = BCF_GetColor("ENEMYNORMALDAMAGE"),
					paneltype = "crit",
					anchor = "BCFG_Message_Knob",
					fontheight = BCF_GetOption("FONTSIZE") * 1.25,
				});
			end
		end,
		commandkey = "SHOWCRITHIT",
	});

	-- 평타 데미지 - 0205
	BCF_Register({
		event = "CHAT_MSG_COMBAT_SELF_HITS",
		pattern = "당신은 (.+)|1을;를; 공격하여 (%d+)의 피해를 입혔습니다.",
		callback = function (event,msg,target,damage)
			if ( BCFG_IsBestDamage(damage,target,"평타") == true ) then
				BCF_DisplayMessage({
					text = "NEW Record!! |cFF33FF33".."평타".."|r : |cFFFF0000"..damage.."|r",
					fontheight = BCF_GetOption("FONTSIZE") * 1.5,
					rgb = {r=0.8,g=0.8,b=0.1},
					paneltype = "sticky",
					anchor = "BCFG_Message_Knob",
					font = "Fonts\\2002b.TTF",
				});
				PlaySound("LEVELUP", 1, 1, 0, 1, 3);
				if ( BCF_GetOption("NEWRECORDSHOT") == 1 ) then
					TakeScreenshot();
				end
			else
				local suffix = BCF_FindSuffix(msg);
				BCF_DisplayMessage({
					text = damage..suffix,
					rgb = BCF_GetColor("ENEMYNORMALDAMAGE"),
					paneltype = "gravity",
					anchor = "BCFG_Message_Knob",
				});
			end
		end,
		commandkey = "SHOWNORMALHIT",
	});

	-- 자동사격 평타 데미지 - 0205
	BCF_Register({
		event = "CHAT_MSG_COMBAT_SELF_HITS",
		pattern = "당신은 (.+)|1으로;로; (.+)에게 (%d+)의 피해를 입혔습니다.",
		callback = function (event,msg,spell,target,damage)
			if ( BCFG_IsBestDamage(damage,target,spell) == true ) then
				BCF_DisplayMessage({
					text = "NEW Record!! |cFF33FF33"..spell.."|r : |cFFFF0000"..damage.."|r",
					fontheight = BCF_GetOption("FONTSIZE") * 1.5,
					rgb = {r=0.8,g=0.8,b=0.1},
					paneltype = "sticky",
					anchor = "BCFG_Message_Knob",
					font = "Fonts\\2002b.TTF",
				});
				PlaySound("LEVELUP", 1, 1, 0, 1, 3);
				if ( BCF_GetOption("NEWRECORDSHOT") == 1 ) then
					TakeScreenshot();
				end
			else
				local suffix = BCF_FindSuffix(msg);
				local text;
				if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
					text = spell.." : "..damage..suffix;
				else
					text = damage..suffix;
				end
				BCF_DisplayMessage({
					text = text,
					fontheight = BCF_GetOption("FONTSIZE"),
					rgb = BCF_GetColor("ENEMYNORMALDAMAGE"),
					paneltype = "gravity",
					anchor = "BCFG_Message_Knob",
				});
			end
		end,
		commandkey = "SHOWNORMALHIT",
	});

	-- 자동사격 치명타 메세지 - 0205
	BCF_Register({
		event = "CHAT_MSG_COMBAT_SELF_HITS",
		pattern = "당신은 (.+)|1으로;로; (.+)에게 (%d+)의 치명상 피해를 입혔습니다.",
		callback = function (event,msg,spell,target,damage)
			if ( BCFG_IsBestDamage(damage,target,spell) == true ) then
				BCF_DisplayMessage({
					text = "NEW Record!! |cFF33FF33"..spell.."|r : |cFFFF0000"..damage.."|r",
					fontheight = BCF_GetOption("FONTSIZE") * 1.5,
					rgb = {r=0.8,g=0.8,b=0.1},
					paneltype = "sticky",
					anchor = "BCFG_Message_Knob",
					font = "Fonts\\2002b.TTF",
				});
				PlaySound("LEVELUP", 1, 1, 0, 1, 3);
				if ( BCF_GetOption("NEWRECORDSHOT") == 1 ) then
					TakeScreenshot();
				end
			else
				local suffix = BCF_FindSuffix(msg);
				local text;
				if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
					text = spell.." : "..damage..suffix;
				else
					text = damage..suffix;
				end
				BCF_DisplayMessage({
					text = text,
					fontheight = BCF_GetOption("FONTSIZE") * 1.25,
					rgb = BCF_GetColor("ENEMYNORMALDAMAGE"),
					paneltype = "crit",
					anchor = "BCFG_Message_Knob",
				});
			end
		end,
		commandkey = "SHOWCRITHIT",
	});


--------------------------------------
-- CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE
--------------------------------------

--------------------------------
-- CHAT_MSG_SPELL_AURA_GONE_SELF
--------------------------------

------------------------------
-- CHAT_MSG_COMBAT_SELF_MISSES
------------------------------

	-- 이하 평타 실패에 대한 메세지
	BCF_Register({ -- 0205
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "당신은 (.+)|1을;를; 공격했지만 적중하지 않았습니다.$",
		msg = MISS,
		rgb = BCF_GetColor("MISS"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
		command = {
			title = "공격 실패 메세지",
			cmd = {"공격실패","hitmiss"},
			helpmsg = "%s: 공격 실패 메세지를 표시합니다.(빗맞힘, 저항, 흡수 등)",
			statusmsg = " 공격 실패 메세지 : %s",
			cmdfunc = function ()
				local r = BCF_GetOption("SHOWHITMISS");
				if ( r == 1 ) then
					BCF_SetOption("SHOWHITMISS", 0);
				else
					BCF_SetOption("SHOWHITMISS", 1);
				end
			end,
		},
	});

	BCF_Register({ -- 0205
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "당신은 (.+)|1을;를; 공격했지만 모든 피해를 흡수했습니다.$",
		msg = ABSORB,
		rgb = BCF_GetColor("ABSORB"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0205
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "당신은 (.+)|1을;를; 공격했지만 방어했습니다.$",
		msg = BLOCK,
		rgb = BCF_GetColor("BLOCK"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0205
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "당신은 (.+)|1을;를; 공격했지만 빗맞았습니다.$",
		msg = DEFLECT,
		rgb = BCF_GetColor("DEFLECT"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0205
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "당신은 (.+)|1을;를; 공격했지만 교묘히 피했습니다.$",
		msg = DODGE,
		rgb = BCF_GetColor("DODGE"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0205
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "당신은 (.+)|1을;를; 공격했지만 빗나갔습니다.$",
		msg = EVADE,
		rgb = BCF_GetColor("EVADE"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0205
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "당신은 (.+)|1을;를; 공격했지만 면역입니다.$",
		msg = IMMUNE,
		rgb = BCF_GetColor("IMMUNE"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0205
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "당신은 (.+)|1을;를; 공격했지만 막았습니다.$",
		msg = PARRY,
		rgb = BCF_GetColor("PARRY"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0205
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "당신은 (.+)|1을;를; 공격했지만 모든 피해를 저항했습니다.$",
		msg = RESIST,
		rgb = BCF_GetColor("RESIST"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "(.+)|1이;가; 당신의 (.+) 공격에 아무런 피해도 입지 않았습니다.$",
		msg = IMMUNE,
		rgb = BCF_GetColor("IMMUNE"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "(.+)|1이;가; 당신의 (.+) 공격에 면역입니다.$",
		msg = IMMUNE,
		rgb = BCF_GetColor("IMMUNE"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "(.+)|1을;를; 공격했지만 피해를 입지 않았습니다.$",
		msg = IMMUNE,
		rgb = BCF_GetColor("IMMUNE"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "자기 자신을 공격했지만 피해를 입지 않았습니다.",
		msg = IMMUNE,
		rgb = BCF_GetColor("IMMUNE"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});

	BCF_Register({ -- 0205
		event = "CHAT_MSG_COMBAT_SELF_MISSES",
		pattern = "(.+)|1이;가; 당신의 (.+)|1을;를; 저항했습니다.",
		msg = RESIST,
		rgb = BCF_GetColor("RESIST"),
		fontheight = BCF_GetOption("FONTSIZE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		commandkey = "SHOWHITMISS",
	});


-------------------------------------
-- CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS
-------------------------------------

------------------------------------------
-- CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE
------------------------------------------

	-- dot to mob
	BCF_Register({
		event = "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE",
		pattern = "(.+)|1이;가; 당신의 (.+)에 의해 (%d+)의 ([신성|화염|자연|냉기|암흑|비전|물리]+) 피해를 입었습니다.",
		commandkey = "SHOWNORMALHIT",
		callback = function(event,msg,target,spell,damage,dtype)
			local text;
			--[[local a,b;
			if SW_FixLogStrings then
				_,_,a,b = string.find(spell,"(.-) 의 (.+)");
			else
				_,_,a,b = string.find(spell,"(.-)의 (.+)");
			end

			if ( a and b
				and not (a=="어둠" and b=="권능: 고통")
				and not (a=="어둠" and b=="권능: 죽음")
				and not (a=="고통" and b=="저주")
			) then
				return;
			end]]
			local rgb;
			local suffix = BCF_FindSuffix(msg);
			if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
				if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
					text = spell.." : "..damage..suffix;
				else
					text = spell.."("..dtype..") : "..damage..suffix;
				end
			else
				text = damage..suffix;
			end
			if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
				if ( dtype == "신성" ) then
					rgb = BCF_GetColor("Holy");
				elseif ( dtype == "화염" ) then
					rgb = BCF_GetColor("Fire");
				elseif ( dtype == "자연" ) then
					rgb = BCF_GetColor("Nature");
				elseif ( dtype == "냉기" ) then
					rgb = BCF_GetColor("Frost");
				elseif ( dtype == "암흑" ) then
					rgb = BCF_GetColor("Shadow");
				elseif ( dtype == "비전" ) then
					rgb = BCF_GetColor("Arcane");
				else
					rgb = BCF_GetColor("ENEMYPERIODICDAMAGE");
				end
			else
				rgb = BCF_GetColor("ENEMYPERIODICDAMAGE");
			end
			BCF_DisplayMessage({
				text = text,
				fontheight = BCF_GetOption("FONTSIZE"),
				rgb = rgb,
				paneltype = "gravity",
				anchor = "BCFG_Message_Knob",
				font = "Fonts\\K_Damage.TTF",
				isStaggered = 1,
			});
		end,
	});

	
-----------------------------------------------
-- CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE
-----------------------------------------------

	-- dot to hostile player
	BCF_Register({
		event = "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE",
		pattern = "(.+)|1이;가; 당신의 (.+)에 의해 (%d+)의 ([신성|화염|자연|냉기|암흑|비전|물리]+) 피해를 입었습니다.",
		commandkey = "SHOWNORMALHIT",
		callback = function(event,msg,target,spell,damage,dtype)
			local text;
			--[[local a,b;
			if SW_FixLogStrings then
				_,_,a,b = string.find(spell,"(.-) 의 (.+)");
			else
				_,_,a,b = string.find(spell,"(.-)의 (.+)");
			end
			if ( a and b
				and not (a=="어둠" and b=="권능: 고통")
				and not (a=="어둠" and b=="권능: 죽음")
				and not (a=="고통" and b=="저주")
			) then
				return;
			end]]
			local rgb;
			local suffix = BCF_FindSuffix(msg);
			if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
				if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
					text = spell.." : "..damage..suffix;
				else
					text = spell.."("..dtype..") : "..damage..suffix;
				end
			else
				text = damage..suffix;
			end
			if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
				if ( dtype == "신성" ) then
					rgb = BCF_GetColor("Holy");
				elseif ( dtype == "화염" ) then
					rgb = BCF_GetColor("Fire");
				elseif ( dtype == "자연" ) then
					rgb = BCF_GetColor("Nature");
				elseif ( dtype == "냉기" ) then
					rgb = BCF_GetColor("Frost");
				elseif ( dtype == "암흑" ) then
					rgb = BCF_GetColor("Shadow");
				elseif ( dtype == "비전" ) then
					rgb = BCF_GetColor("Arcane");
				else
					rgb = BCF_GetColor("ENEMYPERIODICDAMAGE");
				end
			else
				rgb = BCF_GetColor("ENEMYPERIODICDAMAGE");
			end
			BCF_DisplayMessage({
				text = text,
				fontheight = BCF_GetOption("FONTSIZE"),
				rgb = rgb,
				paneltype = "gravity",
				anchor = "BCFG_Message_Knob",
				font = "Fonts\\K_Damage.TTF",
				isStaggered = 1,
			});
		end,
	});

--------------------------------
-- CHAT_MSG_COMBAT_HOSTILE_DEATH
--------------------------------

---------------------------------------
-- CHAT_MSG_SPELL_DAMAGESHIELDS_ON_SELF
---------------------------------------

	-- damageshields : 반사데미지 - 0205
	BCF_Register({
		event = "CHAT_MSG_SPELL_DAMAGESHIELDS_ON_SELF",
		pattern = "당신은 (%d+)의 ([^%s]+) 피해를 (.+)에게 반사했습니다.",
		commandkey = "SHOWNORMALHIT",
		callback = function(event,msg,damage,dtype,target)
			local suffix = BCF_FindSuffix(msg);
			local text;
			if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
				text = damage.." ("..dtype..")"..suffix;
			else
				text = damage..suffix;
			end
			BCF_DisplayMessage({
				text = text,
				fontheight = BCF_GetOption("FONTSIZE"),
				rgb = BCF_GetColor("ENEMYSPELLDAMAGE"),
				paneltype = "gravity",
				anchor = "BCFG_Message_Knob",
				font = "Fonts\\K_Damage.TTF",
				isStaggered = 1,
			});
		end,
	});	

	-- 주문 반사
	BCF_Register({
		event = "CHAT_MSG_SPELL_DAMAGESHIELDS_ON_SELF",
		pattern = "당신은 (.+)의 (.+)|1을;를; 반사했습니다.",
		commandkey = "SHOWNORMALHIT",
		msg = "%1 : 반사!",
		class = "전사",
		rgb = BCF_GetColor("ENEMYSPELLDAMAGE"),
		paneltype = "gravity",
		anchor = "BCFG_Message_Knob",
		fontheight = BCF_GetOption("FONTSIZE"),
	});	

---------------------------
-- CHAT_MSG_COMBAT_PET_HITS
---------------------------

	-- 펫의 일반공격 치명타 데미지
	BCF_Register({
		event = "CHAT_MSG_COMBAT_PET_HITS",
		pattern = "(.+)|1이;가; (.+)|1을;를; 공격하여 (%d+)의 치명상을 입혔습니다.",
		callback = function (event,msg,pet,target,damage)
			local suffix = BCF_FindSuffix(msg);
			BCF_DisplayMessage({
				text = pet..": "..damage..suffix,
				rgb = BCF_GetColor("ENEMYPETNORMALDAMAGE"),
				paneltype = "crit",
				anchor = "BCFG_Message_Knob",
				fontheight = BCF_GetOption("FONTSIZE") * 1.25,
			});
		end,
		commandkey = "SHOWPETHIT",
		command = {
			title = "소환수 공격 메세지",
			cmd = {"소환수공격","pethit"},
			helpmsg = "%s: 소환수의 공격 메세지를 표시합니다.",
			statusmsg = " 소환수 공격 메세지 : %s",
			cmdfunc = function ()
				local r = BCF_GetOption("SHOWPETHIT");
				if ( r == 1 ) then
					BCF_SetOption("SHOWPETHIT", 0);
				else
					BCF_SetOption("SHOWPETHIT", 1);
				end
			end,
		},
	});

	-- 펫의 일반공격 평타 데미지
	BCF_Register({
		event = "CHAT_MSG_COMBAT_PET_HITS",
		pattern = "(.+)|1이;가; (.+)|1을;를; 공격하여 (%d+)의 피해를 입혔습니다.",
		callback = function (event,msg,pet,target,damage)
			local suffix = BCF_FindSuffix(msg);
			BCF_DisplayMessage({
				text = pet..": "..damage..suffix,
				rgb = BCF_GetColor("ENEMYPETNORMALDAMAGE"),
				paneltype = "gravity",
				anchor = "BCFG_Message_Knob",
				fontheight = BCF_GetOption("FONTSIZE"),
			});
		end,
		commandkey = "SHOWPETHIT",
	});

	-- 사제 : 어둠의 마귀 (일반타격, 속성데미지)
	BCF_Register({
		event = "CHAT_MSG_COMBAT_PET_HITS",
		pattern = "(.+)|1이;가; (.+)|1을;를; 공격하여 (%d+)의 ([신성|화염|자연|냉기|암흑|비전|물리]+) 치명상 피해를 입혔습니다.",
		callback = function (event,msg,pet,target,damage,dtype)
			local suffix = BCF_FindSuffix(msg);
			local rgb;
			local text;
			if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
				text = pet..": "..damage.."("..dtype..") "..suffix;
			else
				text = pet..": "..damage..suffix;
			end
			if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
				if ( dtype == "신성" ) then
					rgb = BCF_GetColor("Holy");
				elseif ( dtype == "화염" ) then
					rgb = BCF_GetColor("Fire");
				elseif ( dtype == "자연" ) then
					rgb = BCF_GetColor("Nature");
				elseif ( dtype == "냉기" ) then
					rgb = BCF_GetColor("Frost");
				elseif ( dtype == "암흑" ) then
					rgb = BCF_GetColor("Shadow");
				elseif ( dtype == "비전" ) then
					rgb = BCF_GetColor("Arcane");
				else
					rgb = BCF_GetColor("ENEMYPETNORMALDAMAGE");
				end
			else
				rgb = BCF_GetColor("ENEMYPETNORMALDAMAGE");
			end
			BCF_DisplayMessage({
				text = text,
				rgb = rgb,
				paneltype = "crit",
				anchor = "BCFG_Message_Knob",
				fontheight = BCF_GetOption("FONTSIZE") * 1.25,
			});
		end,
		commandkey = "SHOWPETHIT",
	});

	-- 사제 : 어둠의 마귀 (일반타격, 속성데미지)
	BCF_Register({
		event = "CHAT_MSG_COMBAT_PET_HITS",
		pattern = "(.+)|1이;가; (.+)|1을;를; 공격하여 (%d+)의 ([신성|화염|자연|냉기|암흑|비전|물리]+) 피해를 입혔습니다.",
		callback = function (event,msg,pet,target,damage,dtype)
			local suffix = BCF_FindSuffix(msg);
			local rgb;
			local text;
			if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
				text = pet..": "..damage.."("..dtype..") "..suffix;
			else
				text = pet..": "..damage..suffix;
			end
			if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
				if ( dtype == "신성" ) then
					rgb = BCF_GetColor("Holy");
				elseif ( dtype == "화염" ) then
					rgb = BCF_GetColor("Fire");
				elseif ( dtype == "자연" ) then
					rgb = BCF_GetColor("Nature");
				elseif ( dtype == "냉기" ) then
					rgb = BCF_GetColor("Frost");
				elseif ( dtype == "암흑" ) then
					rgb = BCF_GetColor("Shadow");
				elseif ( dtype == "비전" ) then
					rgb = BCF_GetColor("Arcane");
				else
					rgb = BCF_GetColor("ENEMYPETNORMALDAMAGE");
				end
			else
				rgb = BCF_GetColor("ENEMYPETNORMALDAMAGE");
			end
			BCF_DisplayMessage({
				text = text,
				rgb = rgb,
				paneltype = "gravity",
				anchor = "BCFG_Message_Knob",
				fontheight = BCF_GetOption("FONTSIZE"),
			});
		end,
		commandkey = "SHOWPETHIT",
	});


----------------------------
-- CHAT_MSG_SPELL_PET_DAMAGE
----------------------------

	-- 펫의 주문공격 치명타 데미지(속성)
	BCF_Register({
		event = "CHAT_MSG_SPELL_PET_DAMAGE",
		pattern = "(.+)|1이;가; (.+)|1으로;로; (.+)에게 (%d+)의 ([신성|화염|자연|냉기|암흑|비전|물리]+) 치명상 피해를 입혔습니다.",
		callback = function (event,msg,pet,spell,target,damage,dtype)
			local suffix = BCF_FindSuffix(msg);
			local text;
			local rgb;
			if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
				if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
					text = pet.."의 "..spell..": "..damage..suffix;
				else
					text = pet.."의 "..spell.."("..dtype..") : "..damage..suffix;
				end
			else
				text = pet..": "..damage..suffix;
			end
			if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
				if ( dtype == "신성" ) then
					rgb = BCF_GetColor("Holy");
				elseif ( dtype == "화염" ) then
					rgb = BCF_GetColor("Fire");
				elseif ( dtype == "자연" ) then
					rgb = BCF_GetColor("Nature");
				elseif ( dtype == "냉기" ) then
					rgb = BCF_GetColor("Frost");
				elseif ( dtype == "암흑" ) then
					rgb = BCF_GetColor("Shadow");
				elseif ( dtype == "비전" ) then
					rgb = BCF_GetColor("Arcane");
				else
					rgb = BCF_GetColor("ENEMYPETSPELLDAMAGE");
				end
			else
				rgb = BCF_GetColor("ENEMYPETSPELLDAMAGE");
			end
			BCF_DisplayMessage({
				text = text,
				rgb = rgb,
				paneltype = "crit",
				anchor = "BCFG_Message_Knob",
				fontheight = BCF_GetOption("FONTSIZE") * 1.25,
			});
		end,
		commandkey = "SHOWPETHIT",
	});

	-- 펫의 주문공격 평타 데미지(속성)
	BCF_Register({
		event = "CHAT_MSG_SPELL_PET_DAMAGE",
		pattern = "(.+)|1이;가; (.+)|1으로;로; (.+)에게 (%d+)의 ([신성|화염|자연|냉기|암흑|비전|물리]+) 피해를 입혔습니다.",
		callback = function (event,msg,pet,spell,target,damage,dtype)
			local suffix = BCF_FindSuffix(msg);
			local text;
			local rgb;
			if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
				if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
					text = pet.."의 "..spell..": "..damage..suffix;
				else
					text = pet.."의 "..spell.."("..dtype..") : "..damage..suffix;
				end
			else
				text = pet..": "..damage..suffix;
			end
			if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
				if ( dtype == "신성" ) then
					rgb = BCF_GetColor("Holy");
				elseif ( dtype == "화염" ) then
					rgb = BCF_GetColor("Fire");
				elseif ( dtype == "자연" ) then
					rgb = BCF_GetColor("Nature");
				elseif ( dtype == "냉기" ) then
					rgb = BCF_GetColor("Frost");
				elseif ( dtype == "암흑" ) then
					rgb = BCF_GetColor("Shadow");
				elseif ( dtype == "비전" ) then
					rgb = BCF_GetColor("Arcane");
				else
					rgb = BCF_GetColor("ENEMYPETSPELLDAMAGE");
				end
			else
				rgb = BCF_GetColor("ENEMYPETSPELLDAMAGE");
			end
			BCF_DisplayMessage({
				text = text,
				rgb = rgb,
				paneltype = "gravity",
				anchor = "BCFG_Message_Knob",
				fontheight = BCF_GetOption("FONTSIZE"),
			});
		end,
		commandkey = "SHOWPETHIT",
	});

	-- 펫의 주문공격 치명타 데미지
	BCF_Register({
		event = "CHAT_MSG_SPELL_PET_DAMAGE",
		pattern = "(.+)|1이;가; (.+)|1으로;로; (.+)에게 (%d+)의 치명상 피해를 입혔습니다.",
		callback = function (event,msg,pet,spell,target,damage)
			local text;
			local suffix = BCF_FindSuffix(msg);
			if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
				text = pet.."의 "..spell..": "..damage..suffix;
			else
				text = pet..": "..damage..suffix;
			end
			BCF_DisplayMessage({
				text = text,
				rgb = BCF_GetColor("ENEMYPETSPELLDAMAGE"),
				paneltype = "crit",
				anchor = "BCFG_Message_Knob",
				fontheight = BCF_GetOption("FONTSIZE") * 1.25,
			});
		end,
		commandkey = "SHOWPETHIT",
	});

	-- 펫의 주문공격 평타 데미지
	BCF_Register({
		event = "CHAT_MSG_SPELL_PET_DAMAGE",
		pattern = "(.+)|1이;가; (.+)|1으로;로; (.+)에게 (%d+)의 피해를 입혔습니다.",
		callback = function (event,msg,pet,spell,target,damage)
			local text;
			local suffix = BCF_FindSuffix(msg);
			if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
				text = pet.."의 "..spell..": "..damage..suffix;
			else
				text = pet..": "..damage..suffix;
			end
			BCF_DisplayMessage({
				text = text,
				rgb = BCF_GetColor("ENEMYPETSPELLDAMAGE"),
				paneltype = "gravity",
				anchor = "BCFG_Message_Knob",
				fontheight = BCF_GetOption("FONTSIZE"),
			});
		end,
		commandkey = "SHOWPETHIT",
	});

	-- 펫의 도트 데미지 : NPC
	BCF_Register({
		event = "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE",
		pattern = "(.+)|1이;가; (.+)의 (.+)에 의해 (%d+)의 ([신성|화염|자연|냉기|암흑|비전|물리]+) 피해를 입었습니다.",
		commandkey = "SHOWPETHIT",
		callback = function(event,msg,target,pet,spell,damage,dtype)
			local petname = UnitName("pet");
			local text;
			local rgb;
			local suffix = BCF_FindSuffix(msg);
			if petname == pet then
				if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
					if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
						text = pet.."의 "..spell..": "..damage..suffix;
					else
						text = pet.."의 "..spell.."("..dtype..") : "..damage..suffix;
					end
				else
					text = pet..": "..damage..suffix;
				end
			end
			if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
				if ( dtype == "신성" ) then
					rgb = BCF_GetColor("Holy");
				elseif ( dtype == "화염" ) then
					rgb = BCF_GetColor("Fire");
				elseif ( dtype == "자연" ) then
					rgb = BCF_GetColor("Nature");
				elseif ( dtype == "냉기" ) then
					rgb = BCF_GetColor("Frost");
				elseif ( dtype == "암흑" ) then
					rgb = BCF_GetColor("Shadow");
				elseif ( dtype == "비전" ) then
					rgb = BCF_GetColor("Arcane");
				else
					rgb = BCF_GetColor("ENEMYPERIODICDAMAGE");
				end
			else
				rgb = BCF_GetColor("ENEMYPERIODICDAMAGE");
			end
			BCF_DisplayMessage({
				text = text,
				fontheight = BCF_GetOption("FONTSIZE"),
				rgb = rgb,
				paneltype = "gravity",
				anchor = "BCFG_Message_Knob",
				font = "Fonts\\K_Damage.TTF",
				isStaggered = 1,
			});
		end,
	});

	-- 펫의 도트 데미지 : 적대 플레이어
	BCF_Register({
		event = "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE",
		pattern = "(.+)|1이;가; (.+)의 (.+)에 의해 (%d+)의 ([신성|화염|자연|냉기|암흑|비전|물리]+) 피해를 입었습니다.",
		commandkey = "SHOWPETHIT",
		callback = function(event,msg,target,pet,spell,damage,dtype)
			local petname = UnitName("pet");
			local text;
			local rgb;
			local suffix = BCF_FindSuffix(msg);
			if petname == pet then
				if ( BCF_GetOption("SHOWSPELLNAME") == 1 ) then
					if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
						text = pet.."의 "..spell..": "..damage..suffix;
					else
						text = pet.."의 "..spell.."("..dtype..") : "..damage..suffix;
					end
				else
					text = pet..": "..damage..suffix;
				end
			end
			if ( BCF_GetOption("SHOWTYPECOLOR") == 1 ) then
				if ( dtype == "신성" ) then
					rgb = BCF_GetColor("Holy");
				elseif ( dtype == "화염" ) then
					rgb = BCF_GetColor("Fire");
				elseif ( dtype == "자연" ) then
					rgb = BCF_GetColor("Nature");
				elseif ( dtype == "냉기" ) then
					rgb = BCF_GetColor("Frost");
				elseif ( dtype == "암흑" ) then
					rgb = BCF_GetColor("Shadow");
				elseif ( dtype == "비전" ) then
					rgb = BCF_GetColor("Arcane");
				else
					rgb = BCF_GetColor("ENEMYPERIODICDAMAGE");
				end
			else
				rgb = BCF_GetColor("ENEMYPERIODICDAMAGE");
			end
			BCF_DisplayMessage({
				text = text,
				fontheight = BCF_GetOption("FONTSIZE"),
				rgb = rgb,
				paneltype = "gravity",
				anchor = "BCFG_Message_Knob",
				font = "Fonts\\K_Damage.TTF",
				isStaggered = 1,
			});
		end,
	});
	

-----------------------------------------------
-- /명령어 등록
-----------------------------------------------

	BCF_AddCommand("BCFGMOVE",{
		title = "BCFG위치이동",
		cmd = {"데이지이동","bcfgmove"},
		helpmsg = "%s: BCFG 데미지 표시 메세지를 이동시킬수 있는 앵커를 표시합니다..",
		statusmsg = " BCFG위치이동 : %s",
		cmdfunc = function ()
			local knob = getglobal("BCFG_Message_Knob");
			if ( knob:IsVisible() ) then
				knob:Hide();
			else
				knob:Show();
			end
		end,
		default = 0,
	});

	BCF_AddCommand("NEWRECORDSHOT",{
		title = "신기록스샷",
		cmd = {"신기록스샷","newrecordshot","newrecordscreenshot"},
		helpmsg = "%s: 신기록 데미지가 나올때 자동으로 스크린샷을 저장합니다.",
		statusmsg = " 신기록스샷 : %s",
		cmdfunc = function ()
			local r = BCF_GetOption("NEWRECORDSHOT");
			if ( r ~= 1 ) then
				BCF_SetOption("NEWRECORDSHOT", 1);
			else
				BCF_SetOption("NEWRECORDSHOT", 0);
			end
		end,
		default = 0,
	});

	-- 와우기본ui설정
	BCF_AddCommand("CombatDamage",{
		title = "(기본UI설정) 대상이 받는 피해 표시",
		cmd = {"대상피해표시","uicombatdamage"},
		helpmsg = "%s: 대상이 받는 피해량을 표시해줍니다. 이 설정은 \"게임설정->대상이 받는 피해 표시\"옵션과 동일합니다.",
		statusmsg = " [기본UI]대상이 받는 피해 표시 : %s",
		cmdfunc = function ()
			local r = GetCVar("CombatDamage");
			if ( r ~= 1 ) then
				SetCVar("CombatDamage", "1", "SHOW_DAMAGE_TEXT");
			else
				SetCVar("CombatDamage", "0", "SHOW_DAMAGE_TEXT");
			end
		end,
	});
	BCF_AddCommand("CombatLogPeriodicSpells",{
		title = "(기본UI설정) 주기적인 피해",
		cmd = {"주기적인피해","uiperiodicdamage"},
		helpmsg = "%s: 분쇄나 저주와 같은 주기적인 주문 효과에 의한 피해의 표시 여부를 설정합니다. 이 설정은 \"게임설정->주기적인 피해\"옵션과 동일합니다.",
		statusmsg = " [기본UI]주기적인 피해 : %s",
		cmdfunc = function ()
			local r = GetCVar("CombatLogPeriodicSpells");
			if ( r ~= 1 ) then
				SetCVar("CombatLogPeriodicSpells", "1", "LOG_PERIODIC_EFFECTS");
			else
				SetCVar("CombatLogPeriodicSpells", "0", "LOG_PERIODIC_EFFECTS");
			end
		end,
	});
	BCF_AddCommand("PetMeleeDamage",{
		title = "(기본UI설정) 소환물 공격력",
		cmd = {"소환물공격력","uipetdamage"},
		helpmsg = "%s: 자신의 소환물이 적에게 입히는 피해의 표시 여부를 설정합니다. 이 설정은 \"게임설정->소환물 공격력\"옵션과 동일합니다.",
		statusmsg = " [기본UI]소환물 공격력 : %s",
		cmdfunc = function ()
			local r = GetCVar("PetMeleeDamage");
			if ( r ~= 1 ) then
				SetCVar("PetMeleeDamage", "1", "SHOW_PET_MELEE_DAMAGE");
				SetCVar("PetSpellDamage", "1");
			else
				SetCVar("PetMeleeDamage", "0", "SHOW_PET_MELEE_DAMAGE");
				SetCVar("PetSpellDamage", "0");
			end
		end,
	});
end

function BCFG_RegisterMenu()
	if ( not BlinkMod_RegisterMenu ) then
		return;
	end

	local info;
	local color;


			-- tier 3 : parent = BCFETCCONFIG

			-- Spacer
			info = {};
			info.parentkey = "BCFETCCONFIG";
			info.key = "BCFGSPACER1";
			info.disabled = 1;
			BlinkMod_RegisterMenu(info, 3);

			info = {};
			info.parentkey = "BCFETCCONFIG";
			info.key = "BCFGTITLE";
			info.text = "<BCFG 데미지 표시>";
			info.isTitle = 1;
			info.notCheckable = 1;
			BlinkMod_RegisterMenu( info, 3 );

			info = {};
			info.parentkey = "BCFETCCONFIG";
			info.key = "BCFGMOVE";
			info.text = "위치조정";
			info.tooltipTitle = "BCFG 메세지의 위치조정";
			info.tooltipText = "BCFG 메세지의 위치를 조정할 수 있는 앵커를 표시합니다.";
			info.GetNameFunction = BCFG_BM_MoveName;
			info.ClickFunction = BCFG_BM_MoveClick;
			info.CheckFunction = BCFG_BM_MoveCheck;
			BlinkMod_RegisterMenu( info, 3 );

			info = {};
			info.parentkey = "BCFETCCONFIG";
			info.key = "BCFGNORMALDMG";
			info.text = "평타피해량 표시";
			info.tooltipTitle = "평타피해량 표시";
			info.tooltipText = "적에게 입힌 평타와 주기적인 피해량(주문/스킬포함)을 보여줍니다.";
			info.CheckFunction = BCFG_BM_NormalDmgCheck;
			info.ClickFunction = BCFG_BM_NormalDmgClick;
			BlinkMod_RegisterMenu( info, 3 );

			info = {};
			info.parentkey = "BCFETCCONFIG";
			info.key = "BCFGCRITDMG";
			info.text = "치명타피해량 표시";
			info.tooltipTitle = "치명타피해량 표시";
			info.tooltipText = "적에게 입힌 치명타 피해량(주문/스킬포함)을 보여줍니다.";
			info.CheckFunction = BCFG_BM_CritDmgCheck;
			info.ClickFunction = BCFG_BM_CritDmgClick;
			BlinkMod_RegisterMenu( info, 3 );

			info = {};
			info.parentkey = "BCFETCCONFIG";
			info.key = "BCFGPETHIT";
			info.text = "소환수 공격 표시";
			info.tooltipTitle = "소환수 공격 표시";
			info.tooltipText = "소환수가 적에게 입힌 피해량(주문/스킬포함)을 보여줍니다.";
			info.CheckFunction = BCFG_BM_PetHitCheck;
			info.ClickFunction = BCFG_BM_PetHitClick;
			BlinkMod_RegisterMenu( info, 3 );

			info = {};
			info.parentkey = "BCFETCCONFIG";
			info.key = "BCFGBESTDMGSS";
			info.text = "신기록스샷";
			info.tooltipTitle = "신기록스샷";
			info.tooltipText = "신기록 데미지가 나올때 자동으로 스크린샷을 저장합니다.";
			info.CheckFunction = BCFG_BM_NewRecordShotCheck;
			info.ClickFunction = BCFG_BM_NewRecordShotClick;
			BlinkMod_RegisterMenu( info, 3 );

			info = {};
			info.parentkey = "BCFETCCONFIG";
			info.key = "BCFGSHOWUICOMBATDAMAGE";
			info.text = "[UI]대상이 받는 피해 표시";
			info.tooltipTitle = "[UI]대상이 받는 피해 표시";
			info.tooltipText = "대상이 받는 피해량을 표시해줍니다. 이 설정은 \"게임설정->대상이 받는 피해 표시\"옵션과 동일합니다.";
			info.CheckFunction = BCFG_BM_UICombatDamageCheck;
			info.ClickFunction = BCFG_BM_UICombatDamageClick;
			BlinkMod_RegisterMenu( info, 3 );

			info = {};
			info.parentkey = "BCFETCCONFIG";
			info.key = "BCFGSHOWUIPERIODICDAMAGE";
			info.text = "[UI]주기적인 피해";
			info.tooltipTitle = "[UI]주기적인 피해";
			info.tooltipText = "분쇄나 저주와 같은 주기적인 주문 효과에 의한 피해의 표시 여부를 설정합니다. 이 설정은 \"게임설정->주기적인 피해\"옵션과 동일합니다.";
			info.CheckFunction = BCFG_BM_UIPeriodicDamageCheck;
			info.ClickFunction = BCFG_BM_UIPeriodicDamageClick;
			BlinkMod_RegisterMenu( info, 3 );

			info = {};
			info.parentkey = "BCFETCCONFIG";
			info.key = "BCFGSHOWUIPETDAMAGE";
			info.text = "[UI]소환물 공격력";
			info.tooltipTitle = "[UI]소환물 공격력";
			info.tooltipText = "자신의 소환물이 적에게 입히는 피해의 표시 여부를 설정합니다. 이 설정은 \"게임설정->소환물 공격력\"옵션과 동일합니다.";
			info.CheckFunction = BCFG_BM_UIPetDamageCheck;
			info.ClickFunction = BCFG_BM_UIPetDamageClick;
			BlinkMod_RegisterMenu( info, 3 );



			-- tier 3 : parent = BCFSETCOLOR

			-- Spacer
			info = {};
			info.parentkey = "BCFSETCOLOR";
			info.key = "BCFGSPACER2";
			info.disabled = 1;
			BlinkMod_RegisterMenu(info, 3);

			info = {};
			info.parentkey = "BCFSETCOLOR";
			info.key = "BCFGTITLECOLOR";
			info.text = "<BCFG 데미지 색상설정>";
			info.isTitle = 1;
			info.notCheckable = 1;
			BlinkMod_RegisterMenu( info, 3 );

			color = BCF_GetColor("ENEMYNORMALDAMAGE");
			info = {};
			info.parentkey = "BCFSETCOLOR";
			info.key = "BCFCOLORENEMYNORMALDAMAGE";
			info.text = "일반 공격 색상";
			info.tooltipTitle = "일반 공격 색상";
			info.tooltipText = "일반 공격을 나타내는 색상을 설정합니다.";
			info.hasColorSwatch = 1;
			info.r = color.r;
			info.g = color.g;
			info.b = color.b;
			info.swatchFunc = BCFG_BM_NormalDmgSwatch;
			info.cancelFunc = BCFG_BM_NormalDmgCancel;
			info.func = UIDropDownMenuButton_OpenColorPicker;
			info.opacity = 1.0;
			BlinkMod_RegisterMenu( info, 3 );

			color = BCF_GetColor("ENEMYSPELLDAMAGE");
			info = {};
			info.parentkey = "BCFSETCOLOR";
			info.key = "BCFCOLORENEMYSPELLDAMAGE";
			info.text = "주문/스킬 공격 색상";
			info.tooltipTitle = "주문/스킬 공격 색상";
			info.tooltipText = "주문/스킬 공격을 나타내는 색상을 설정합니다.";
			info.hasColorSwatch = 1;
			info.r = color.r;
			info.g = color.g;
			info.b = color.b;
			info.swatchFunc = BCFG_BM_SpellDmgSwatch;
			info.cancelFunc = BCFG_BM_SpellDmgCancel;
			info.func = UIDropDownMenuButton_OpenColorPicker;
			info.opacity = 1.0;
			BlinkMod_RegisterMenu( info, 3 );

			color = BCF_GetColor("ENEMYPERIODICDAMAGE");
			info = {};
			info.parentkey = "BCFSETCOLOR";
			info.key = "BCFCOLORENEMYPERIODICDAMAGE";
			info.text = "주기적인 피해";
			info.tooltipTitle = "주기적인 피해 색상";
			info.tooltipText = "주기적인 피해를 나타내는 색상을 설정합니다.";
			info.hasColorSwatch = 1;
			info.r = color.r;
			info.g = color.g;
			info.b = color.b;
			info.swatchFunc = BCFG_BM_PeriodicDmgSwatch;
			info.cancelFunc = BCFG_BM_PeriodicDmgCancel;
			info.func = UIDropDownMenuButton_OpenColorPicker;
			info.opacity = 1.0;
			BlinkMod_RegisterMenu( info, 3 );

			color = BCF_GetColor("ENEMYPETNORMALDAMAGE");
			info = {};
			info.parentkey = "BCFSETCOLOR";
			info.key = "BCFCOLORENEMYPETNORMALDAMAGE";
			info.text = "소환수의 일반 공격 색상";
			info.tooltipTitle = "소환수의 일반 공격 색상";
			info.tooltipText = "소환수의 일반 공격을 나타내는 색상을 설정합니다.";
			info.hasColorSwatch = 1;
			info.r = color.r;
			info.g = color.g;
			info.b = color.b;
			info.swatchFunc = BCFG_BM_PetNormalDmgSwatch;
			info.cancelFunc = BCFG_BM_PetNormalDmgCancel;
			info.func = UIDropDownMenuButton_OpenColorPicker;
			info.opacity = 1.0;
			BlinkMod_RegisterMenu( info, 3 );

			color = BCF_GetColor("ENEMYPETSPELLDAMAGE");
			info = {};
			info.parentkey = "BCFSETCOLOR";
			info.key = "BCFCOLORENEMYPETSPELLDAMAGE";
			info.text = "소환수의 주문/스킬 색상";
			info.tooltipTitle = "소환수의 주문/스킬 색상";
			info.tooltipText = "소환수의 주문/스킬 공격을 나타내는 색상을 설정합니다.";
			info.hasColorSwatch = 1;
			info.r = color.r;
			info.g = color.g;
			info.b = color.b;
			info.swatchFunc = BCFG_BM_PetSpellDmgSwatch;
			info.cancelFunc = BCFG_BM_PetSpellDmgCancel;
			info.func = UIDropDownMenuButton_OpenColorPicker;
			info.opacity = 1.0;
			BlinkMod_RegisterMenu( info, 3 );
end

-------------------------------------------------------------------------------
function BCFG_BM_MoveClick()
	local knob = getglobal("BCFG_Message_Knob");
	if ( knob:IsVisible() ) then
		knob:Hide();
	else
		knob:Show();
	end
end
function BCFG_BM_MoveName()
	local knob = getglobal("BCFG_Message_Knob");
	if ( knob:IsVisible() ) then
		return "위치조정 : 이동가능";
	else
		return "위치조정 : 고정됨";
	end
end
function BCFG_BM_MoveCheck()
	local knob = getglobal("BCFG_Message_Knob");
	if ( knob:IsVisible() ) then
		return true;
	else
		return false;
	end
end
-------------------------------------------------------------------------------
function BCFG_BM_CritDmgClick()
	local r = BCF_GetOption("SHOWCRITHIT");
	if ( r == 1 ) then
		BCF_SetOption("SHOWCRITHIT", 0);
	else
		BCF_SetOption("SHOWCRITHIT", 1);
	end
end

function BCFG_BM_CritDmgCheck()
	if ( BCF_GetOption("SHOWCRITHIT") == 1 ) then
		return true;
	else
		return false;
	end
end
-------------------------------------------------------------------------------
function BCFG_BM_NormalDmgClick()
	local r = BCF_GetOption("SHOWNORMALHIT");
	if ( r == 1 ) then
		BCF_SetOption("SHOWNORMALHIT", 0);
	else
		BCF_SetOption("SHOWNORMALHIT", 1);
	end
end

function BCFG_BM_NormalDmgCheck()
	if ( BCF_GetOption("SHOWNORMALHIT") == 1 ) then
		return true;
	else
		return false;
	end
end
-------------------------------------------------------------------------------
function BCFG_BM_PetHitClick()
	local r = BCF_GetOption("SHOWPETHIT");
	if ( r == 1 ) then
		BCF_SetOption("SHOWPETHIT", 0);
	else
		BCF_SetOption("SHOWPETHIT", 1);
	end
end

function BCFG_BM_PetHitCheck()
	if ( BCF_GetOption("SHOWPETHIT") == 1 ) then
		return true;
	else
		return false;
	end
end
-------------------------------------------------------------------------------
function BCFG_BM_NewRecordShotClick()
	local r = BCF_GetOption("NEWRECORDSHOT");
	if ( r == 1 ) then
		BCF_SetOption("NEWRECORDSHOT", 0);
	else
		BCF_SetOption("NEWRECORDSHOT", 1);
	end
end

function BCFG_BM_NewRecordShotCheck()
	if ( BCF_GetOption("NEWRECORDSHOT") == 1 ) then
		return true;
	else
		return false;
	end
end
-------------------------------------------------------------------------------
function BCFG_BM_UICombatDamageClick()
	local r = GetCVar("CombatDamage");
	if ( r ~= "1" ) then
		SetCVar("CombatDamage", "1", "SHOW_DAMAGE_TEXT");
	else
		SetCVar("CombatDamage", "0", "SHOW_DAMAGE_TEXT");
	end
end

function BCFG_BM_UICombatDamageCheck()
	if ( GetCVar("CombatDamage") == "1" ) then
		return true;
	else
		return false;
	end
end
-------------------------------------------------------------------------------
function BCFG_BM_UIPeriodicDamageClick()
	local r = GetCVar("CombatLogPeriodicSpells");
	if ( r ~= "1" ) then
		SetCVar("CombatLogPeriodicSpells", "1", "LOG_PERIODIC_EFFECTS");
	else
		SetCVar("CombatLogPeriodicSpells", "0", "LOG_PERIODIC_EFFECTS");
	end
end

function BCFG_BM_UIPeriodicDamageCheck()
	if ( GetCVar("CombatDamage") ~= "1" ) then
		return false;
	else
		if ( GetCVar("CombatLogPeriodicSpells") == "1" ) then
			return true;
		else
			return false;
		end
	end
end
-------------------------------------------------------------------------------
function BCFG_BM_UIPetDamageClick()
	local r = GetCVar("PetMeleeDamage");
	if ( r ~= "1" ) then
		SetCVar("PetMeleeDamage", "1", "SHOW_PET_MELEE_DAMAGE");
		SetCVar("PetSpellDamage", "1");
	else
		SetCVar("PetMeleeDamage", "0", "SHOW_PET_MELEE_DAMAGE");
		SetCVar("PetSpellDamage", "0");
	end
end

function BCFG_BM_UIPetDamageCheck()
	if ( GetCVar("CombatDamage") ~= "1" ) then
		return false;
	else
		if ( GetCVar("PetMeleeDamage") == "1" ) then
			return true;
		else
			return false;
		end
	end
end
-------------------------------------------------------------------------------
function BCFG_BM_NormalDmgSwatch()
	BCF_BM_SaveColor("ENEMYNORMALDAMAGE");
end
function BCFG_BM_NormalDmgCancel(previousValues)
	BCF_BM_SaveCancelColor("ENEMYNORMALDAMAGE",previousValues);
end
-------------------------------------------------------------------------------
function BCFG_BM_SpellDmgSwatch()
	BCF_BM_SaveColor("ENEMYSPELLDAMAGE");
end
function BCFG_BM_SpellDmgCancel(previousValues)
	BCF_BM_SaveCancelColor("ENEMYSPELLDAMAGE",previousValues);
end
-------------------------------------------------------------------------------
function BCFG_BM_PeriodicDmgSwatch()
	BCF_BM_SaveColor("ENEMYPERIODICDAMAGE");
end
function BCFG_BM_PeriodicDmgCancel(previousValues)
	BCF_BM_SaveCancelColor("ENEMYPERIODICDAMAGE",previousValues);
end
-------------------------------------------------------------------------------
function BCFG_BM_PetNormalDmgSwatch()
	BCF_BM_SaveColor("ENEMYPETNORMALDAMAGE");
end
function BCFG_BM_PetNormalDmgCancel(previousValues)
	BCF_BM_SaveCancelColor("ENEMYPETNORMALDAMAGE",previousValues);
end
-------------------------------------------------------------------------------
function BCFG_BM_PetSpellDmgSwatch()
	BCF_BM_SaveColor("ENEMYPETSPELLDAMAGE");
end
function BCFG_BM_PetSpellDmgCancel(previousValues)
	BCF_BM_SaveCancelColor("ENEMYPETSPELLDAMAGE",previousValues);
end